/*
 * Copyright (C) Microsoft Corporation, 1982
 */
#
/*

	    	C compiler, part 2


*/

#include "c1.h"
#include <signal.h>
#include <setjmp.h>

int cxpr_debug;
int rcxp_debug;
int aopt_debug;
int bopt_debug;
int dela_debug;
int stkbound;

/* used to pass whether we are going to use the value of this
   assignment or not through multiple recursions. it is used for
   constructs like f=j=k; so we keep the 8087 stack adjusted right
*/
int forvalue = 0;

char	maprel[] {	EQUAL, NEQUAL, GREATEQ, GREAT, LESSEQ,
			LESS, GREATQP, GREATP, LESSEQP, LESSP
};

char	notrel[] {	NEQUAL, EQUAL, GREAT, GREATEQ, LESS,
			LESSEQ, GREATP, GREATQP, LESSP, LESSEQP
};

char    *reg_names[] { "ax", "dx", "si", "di", "cx", "bx", "bp", "sp" };

struct tconst czero { CON, INT, 0};
struct tconst cone  { CON, INT, 1};

struct tname sfuncr { NAME, STRUCT, STATIC, 0, 0, 0 };

struct	table	*cregtab;

int	nreg	3;
int	isn	10000;

struct tnode *recurtree = 0;
int recurcount = 0;

fpsig()
	{
	extern jmp_buf fpenv;
	error("floating point over or under flow\n") ;
	longjmp(fpenv,1) ;
	}

main(argc, argv)
char *argv[];
{
	char c, *p;
	int i;

	if (argc<4) {
		error("Arg count");
		exit(1);
	}
	if (freopen(argv[1], "r", stdin)==NULL) {
		error("Missing temp file");
		exit(1);
	}
	if ((freopen(argv[3], "w", stdout)) == NULL) {
		error("Can't create %s", argv[3]);
		exit(1);
	}
	for(i=4;i<argc;i++)
		{
		for (p=argv[i]; c= *p;p++)
			{
			switch (c) {
				case 'c': cxpr_debug = 1; break;
				case 'r': rcxp_debug = 1; break;
				case 'a': aopt_debug = 1; break;
				case 'b': bopt_debug = 1; break;
				case 'd': dela_debug = 1; break;
#ifdef DEBUG
				case 't': dbinit("trc");  break;
#endif
				case 's': 
				/* this somehow got broken.  fixed it
				   again.  -Hans Aug 28, 1982 */
					stkbound = atoi(p+1);
					continue;
#ifdef DEBUG
				case 'T': 
					dbinit(argv[++i]) ;
			  		continue;
#endif
				}
			}
		}
	signal(SIGFPE,fpsig) ;		/* catch floating point interupts */
	funcbase = curbase = coremax = sbrk(0);
	getree();
	/*
	 * If any floating-point instructions
	 * were used, generate a reference that
	 * pulls in the floating-point part of printf.
	 */
	if (nfloat)
		printf(".globl	fltused\n");
	/*
	 * tack on the string file.
	 */
	printf(".data\n");
	if (*argv[2] != '-') {
		if (freopen(argv[2], "r", stdin)==NULL) {
			error("Missing temp file");
			exit(1);
		}
		getree();
	}
	if (totspace >= (unsigned)56000) {
		error("Warning: possibly too much data");
		nerror--;
	}
	exit(nerror!=0);
}

/*
 * Given a tree, a code table, and a
 * count of available registers, find the code table
 * for the appropriate operator such that the operands
 * are of the right type and the number of registers
 * required is not too large.
 * Return a ptr to the table entry or 0 if none found.
 */
char *
match(atree, table, nrleft, nocvt)
struct tnode *atree;
struct table *table;
{
#define	NOCVL	1
#define	NOCVR	2
	int op, d1, d2, dope;
	struct tnode *p2;
	register struct tnode *p1, *tree;
	register struct optab *opt;

	if ((tree=atree)==0)
		return(0);
	if ((op = tree->op)==0)
		return(0);
	dope = opdope[op];
	if ((dope&LEAF) == 0)
		p1 = tree->tr1;
	else
		p1 = tree;
	d1 = dcalc(p1, nrleft);
	  /* I added the second half of the conjunct because
	     when generating for calls, we zero this to hide
	     the arguments, which have already been generated.
		- Hans */
	if ((dope&BINARY)!=0 && (p2 = tree->tr2) != NULL) {
		/*
		 * If a subtree starts off with a conversion operator,
		 * try for a match with the conversion eliminated.
		 * E.g. int = double can be done without generating
		 * the converted int in a register by
		 * movf double,fr0; movfi fr0,int .
		 */
		if (opdope[p2->op]&CNVRT && (nocvt&NOCVR)==0
			 && (opdope[p2->tr1->op]&CNVRT)==0) {
			tree->tr2 = p2->tr1;
			if (opt = match(tree, table, nrleft, NOCVL))
				return(opt);
			tree->tr2 = p2;
		} else if (opdope[p1->op]&CNVRT && (nocvt&NOCVL)==0
		 && (opdope[p1->tr1->op]&CNVRT)==0) {
			tree->tr1 = p1->tr1;
			if (opt = match(tree, table, nrleft, NOCVR))
				return(opt);
			tree->tr1 = p1;
		}
		d2 = dcalc(p2, nrleft);
	}
#if DEBUG
	dbprt("tree","searching for match to opcode %d,%s\n",op,opntab[op]);
#endif
	for (; table->op!=op; table++)
		if (table->op==0)
			return(0);
#if DEBUG
	dbprt("tree","match: op=%d,nrleft=%d d1=%d d2=%d\n",op,nrleft,d1,d2);
#endif
	for (opt = table->tabp; opt->tabdeg1!=0; opt++) {
#if DEBUG
	dbprt("tree","match: deg1=0%o typ1=0%o deg2=0%o typ2=0%o\n",
	opt->tabdeg1,opt->tabtyp1,opt->tabdeg2,opt->tabtyp2); 
#endif
		if (d1 > (opt->tabdeg1&077)
		 || (opt->tabdeg1 >= 0100 && p1->op!=STAR && p1->op!=STARPLUS))
			continue;
		if (notcompat(p1, opt->tabtyp1, op)) {
			continue;
		}
		if ((opdope[op]&BINARY)!=0 && p2!=0) {
			if (d2 > (opt->tabdeg2&077)
			 ||(opt->tabdeg2>=0100&&p2->op!=STAR&&p2->op!=STARPLUS))
				continue;
			if (notcompat(p2,opt->tabtyp2, 0))
				continue;
		}
		return(opt);
	}
	return(0);
}

/*
 * Given a tree, a code table, and a register,
 * produce code to evaluate the tree with the appropriate table.
 * Registers reg and up can be used.
 * If there is a value, it is desired that it appear in reg.
 * The routine returns the register in which the value actually appears.
 * This routine must work or there is an error.
 * If the table called for is cctab, sptab, or efftab,
 * and tree can't be done using the called-for table,
 * another try is made.
 * If the tree can't be compiled using cctab, regtab is
 * used and a "tst" instruction is produced.
 * If the tree can't be compiled using sptab,
 * regtab is used and the register is pushed on the stack.
 * If the tree can't be compiled using efftab,
 * just use regtab.
 * Regtab must succeed or an "op not found" error results.
 *
 * A number of special cases are recognized, and
 * there is an interaction with the optimizer routines.
 */
rcexpr(atree, atable, reg)
struct tnode *atree;
struct table *atable;
{
	int nargs, recurf,dtree();
	register struct tnode *tree;
	register struct table *table;
	register r,opd,fps,valflg;
#if DEBUG
	dbprt("trc","trc - rcexpr called for tree %d,type %x\n",
		atree->op,atree->type) ;
#endif
	if (rcxp_debug) {printf("**rcexpr**\n");
			 dtree(atree, 0);}
	table = atable;
	recurf = 0;
	if (reg<0) {
		recurf++;
		reg = ~reg;
		if (reg>=020) {
			reg =- 020;
			recurf++;
		}
	}
again:
	if((tree=atree)==0)
		return(0);
	if (opdope[tree->op]&RELAT && tree->tr2->op==CON && tree->tr2->value==0
	 && table==cctab)
		{
#ifdef DEBUG
		dbprt("trc","rcexpr droping relational against zero\n") ;
#endif
		tree = atree = tree->tr1;
		}
	/*
	 * fieldselect(...) : in efftab mode,
	 * ignore the select, otherwise
	 * do the shift and mask.
	 */
	if (tree->op == FSELT) {
		if (table==efftab)
			atree = tree = tree->tr1;
		else {
			tree->op = FSEL;
			atree = tree = optim(tree);
		}
	}
	switch (tree->op)  {

	/*
	 * Structure assignments
	 */
	case STRASG:
		strasg(tree);
		return(0);

	/*
	 * An initializing expression
	 */
	case INIT:
		tree = optim(tree);
		doinit(tree->type, tree->tr1);
		return(0);

	/*
	 * Put the value of an expression in ax,
	 * for a switch or a return
	 */
	case RFORCE:
#if DEBUG
		dbprt("trc","rcexpr for RFORCE\n") ;
#endif
		forvalue++;
		if (tree->tr1->type==FLOAT ||
		    tree->tr1->type==DOUBLE)
		{ 
			r=rcexpr(tree->tr1,regtab,reg);
			forvalue--;
			fpstack--;
#ifdef INTERMED
#ifdef IEEE
			printf("fstdp\tfac\nfwait\nlea\tax,fac\n");
#else
			printf("lea\tax,fac\ncalli\tfstdp\nlea\tax,fac\n");
#endif
#else
#ifdef IEEE
			printf("fstdp\tfac\nfwait\nlea\tax,fac\n");
#else
			printf("lea\tax,fac\ncall\tfstdp\nlea\tax,fac\n");
#endif
#endif
		   	return(AX);
		};
		if (TESTL(tree->tr1)) { 
			if ((r=rcexpr(tree->tr1,regtab,reg)) != DX)
				movreg(r,DX,tree->tr1);
			forvalue--;
		   	return(DX);
		};
		if((r=rcexpr(tree->tr1, regtab, reg)) != AX) movreg(r, AX, tree->tr1);
		if (tree->tr1->type == CHAR)
			printf("cbw\n");
		forvalue--;
		return(AX);

	/*
	 * sequential execution
	 */
	case SEQNC:
		r = nstack;			/* save register and fp stack */
		fps = fpstack;			/* and treat as pristine tree */
		valflg = forvalue;
		forvalue = 0 ;
#ifdef DEBUG
		dbprt("comma","SEQNC generation code for tree->tr1  op %d\n",
		tree->tr1->op) ;
#endif
		rcexpr(tree->tr1, efftab, reg);
		nstack = r;			/* restore stacks */
		fpstack = fps;			/* and continue with tree in */
		forvalue = valflg;		/* its previous condition */
		atree = tree = tree->tr2;
#ifdef DEBUG
		dbprt("comma","SEQNC repeating for tree->tr2  op %d\n",
		tree->op) ;
#endif
		goto again;

	/*
	 * Handle a subroutine call. It has to be done
	 * here because if cexpr got called twice, the
	 * arguments might be compiled twice.
	 */
	case CALLSTAR:
	case CALL:
#if DEBUG
		dbprt("trc","trc - rcexpr called for CALL\n") ;
#endif
		r = 0;
		nargs = 0;
		if (tree->tr1->op!=NAME || tree->tr1->class!=EXTERN) {
			nargs++;
			nstack++;
		}
		tree = tree->tr2;
		if(tree->op) {
			while (tree->op==COMMA) {
				r =+ comarg(tree->tr2, reg);
				tree = tree->tr1;
				nargs++;
			}
			r =+ comarg(tree, reg);
			nargs++;
		}
		tree = atree;
		tree->op = tree->op == CALL ? CALL2: CALLSTAR;
		tree->tr2 = NULL;
		if (cexpr(tree, regtab, reg)<0)
			error("compiler botch: call");
		popstk(r);
		nstack =- nargs;
		if (isfloat(tree) && atable != efftab)
		{
#ifdef INTERMED
#ifdef IEEE
			printf("fldd\tfac\n");
#else
			printf("calli\tfldd\n");
#endif
#else
#ifdef IEEE
			printf("fldd\tfac\n");
#else
			printf("call\tfldd\n");
#endif
#endif
			fpstack++;
			/* if we are in a nested call, or
			   something... -Hans, Apr 19, 1982 */
			if (table == sptab) goto fixup;
			return(AX);
		}
		r = TESTL(tree)? DX:AX;
		if (table==efftab || table==regtab)
			return(r);
		goto fixup;

	case CTOI:
		forvalue++;
		r = rcexpr(tree->tr1,table,reg);
		forvalue--;
		return (r);

	case AMPER:
#if DEBUG
		dbprt("trc","rcexpr for AMPER\n") ;
#endif
		if (tree->tr1->op==NAME && tree->tr1->class == OFFS) {
			printf("lea	%s,", reg_names[r=reg]);
			pvalue(tree->tr1->offset);
			printf("(%s)\n", reg_names[tree->tr1->regno]);
			goto fixup;
		}

	/*
	 * Longs need special treatment.
	 */
	case ASLSH:
	case LSHIFT:
		if (TESTL(tree)) {
			if (tree->tr2->op==ITOL)
				tree->tr2 = tree->tr2->tr1;
			else
				if(TESTL(tree->tr2))
				tree->tr2 = optim(tnode(LTOI,INT,tree->tr2));
/*
			if (tree->op==ASLSH)
				tree->op = ASLSHL;
			else
				tree->op = LLSHIFT;
*/
		}
		break;

	/*
	 * Try to change * to shift.
	 */
	case TIMES:
	case ASTIMES:
		tree = pow2(tree);
	}
	/*
	 * Try to find postfix ++ and -- operators that can be
	 * pulled out and done after the rest of the expression
	 */
	if (table!=cctab && table!=cregtab && recurf<2
	 && (opdope[tree->op]&LEAF)==0) {
		if (r=delay(&atree, table, reg)) {
			tree = atree;
			table = efftab;
			reg = r-1;
		}
	}
	/*
	 * Basically, try to reorder the computation
	 * so  reg = x+y  is done as  reg = x; reg =+ y
	 */
	if (recurf==0 && reorder(&atree, table, reg)) {
		if (table==cctab && atree->op==NAME)
			return(reg);
	}
	tree = atree;
	if (table==efftab && tree->op==NAME)
		return(reg);
	forvalue++;
	r=cexpr(tree, table, reg);
	forvalue--;
	if (r>=0)
		{
#ifdef DEBUG
		dbprt("trc","trc - cexpr returned %d\n",r) ;
#endif
		return(r);
		}

#if DEBUG
	dbprt("trc","trc - rcexpr returning negative value\n") ;
#endif
	if (table == cctab && TESTL(tree))
		return(-1); /* can't use the code below for longs !! */
	if (table!=regtab && (table!=cctab||(opdope[tree->op]&RELAT)==0)) {
		if((r=cexpr(tree, regtab, reg))>=0) {
	fixup:
#if DEBUG
	dbprt("trc","trc - rcexpr at start of fixup\n") ;
#endif
		if (table==sptab) {
			if (TESTL(tree)){
				printf("push\t%s\n",reg_names[r-1]);
				printf("push\t%s\n",reg_names[r]);
				nstack+=2;
			}
			else if (tree->type==DOUBLE || tree->type==FLOAT) {
#ifdef INTERMED
#ifdef IEEE
				printf("sub\tsp,*8\nxchg\tax,si\nmov\tsi,sp\nfstdp\t(si)\nfwait\nxchg\tax,si\n");
#else
				printf("sub\tsp,*8\nmov\tax,sp\ncalli\tfstdp\n");
#endif
#else
#ifdef IEEE
				printf("sub\tsp,*8\nxchg\tax,si\nmov\tsi,sp\nfstdp\t(si)\nfwait\nxchg\tax,si\n");
#else
				printf("sub\tsp,*8\nmov\tax,sp\ncall\tfstdp\n");
#endif
#endif
				fpstack--;
				nstack+=4;
			}
			else {
				printf("push\t%s\n",reg_names[r]);
				nstack++;
			}
		}
		if(table==cctab && tree->type != DOUBLE && tree->type !=FLOAT) {
			if (tree->type == CHAR)
				{
				if(r>SI)
					{
					movreg(r,DX,tree) ;
					r = DX ;
					}
				printf("orb");
				}
			else
				printf("or");
			printf("\t%s,%s\n",reg_names[r],reg_names[r]);
		}
		return(r);
	}
	}
	/*
	 * There's a last chance for this operator
	 */
	if (tree->op==LTOI) {
		forvalue++;
		r = rcexpr(tree->tr1, regtab, reg);
		forvalue--;
		if (r >= 0) {
			r--;
			goto fixup;
		}
	}
	if (tree->type == STRUCT)
		error("Illegal operation on structure");
	else if (tree->op>0 && tree->op<RFORCE && opntab[tree->op])
		error("No code table for op: %s", opntab[tree->op]);
	else
		error("No code table for op %d", tree->op);
	return(reg);
}

/*
 * Try to compile the tree with the code table using
 * registers areg and up.  If successful,
 * return the register where the value actually ended up.
 * If unsuccessful, return -1.
 *
 * Most of the work is the macro-expansion of the
 * code table.
 */
cexpr(atree, table, areg)
struct tnode *atree;
struct table *table;
{
	int c, r;
	register struct tnode *p, *p1, *tree;
	struct table *ctable;
	struct tnode *p2;
	struct lconst lp;
	char *string;
	int reg, reg1, rreg, flag, opd;
	int r1isbx,r2isbx, regisax;
	char *opt;

#if DEBUG
	dbprt("trc","trc - cexpr called,op %d,type %x,reg %d\n",
	atree->op, atree->type, areg) ;
#endif
	if(cxpr_debug) {printf("**cexpr**\n");
			dtree(atree,0);}
	tree = atree;
	reg = areg;
	/* lets detect this if we can. Hans Jan 4, 1982 */
	if (recurtree==tree)
	{
		if(++recurcount>15)
		{
			error("internal error: infinite recursion");
			exit(1);
		}
	}
	else
	{
		recurtree = tree;
		recurcount = 0;
	}
	c = tree->op;
	opd = opdope[c];
	p1 = tree->tr2;
	/* can't use SI and DI as character registers */
	if (((opd&RELAT && (p1->type==CHAR)) || tree->type==CHAR) && reg>=SI)
		reg = DX;
	/*
	 * When the value of a relational or a logical expression is
	 * desired, more work must be done.
	 */
	if ((opd&RELAT||c==LOGAND||c==LOGOR||c==EXCLA) && table!=cctab) {
		/* we we cant do longs in a register lower than DX.
		   -Hans, Mar 16, 1982 */
		if (islng(tree->tr1) && reg <= AX)
			cbranch(tree, c=isn++, 1, DX);
		else
			cbranch(tree, c=isn++, 1, reg);
		rcexpr(&czero, table, reg);
		branch(isn, 0);
		label(c);
		rcexpr(&cone, table, reg);
		label(isn++);
		goto cxpr_ret;
	}
	if(c==QUEST) {
		if (table==cctab)
			return(-1);
		cbranch(tree->tr1, c=isn++, 0, reg);
		flag = nstack;
		rreg = rcexpr(p1->tr1, table, reg);
		nstack = flag;
		branch(r=isn++, 0);
		label(c);
		reg = rcexpr(p1->tr2, table, rreg);
		if (rreg!=reg)
			movreg(reg, rreg, p1->tr2);
		label(r);
		/*
		   if both sides of the ':' are floats, then we
		   did two floating pushes, but in different code
		   paths.  we will only pop once, so fake the second
		   one.  unless we are pushing arguments, in which
		   case we cleaned up after ourselves anyways
		 */
		if (table!=sptab &&
		    isfloat (p1->tr1) && isfloat(p1->tr2)) --fpstack;
		reg = rreg;
		goto cxpr_ret;
	}
/*	reg = oddreg(tree, reg); */

	/* we need to make sure we dont ever get garbage registers,
	   ever.  bump it.  -Hans, Dec 12, 1982 */
	if (TESTL(tree) && reg <= AX) reg = DX;

	reg1 = reg-1;
	/*
	 * long values take 2 registers.
	 */
	if ((TESTL(tree)||opd&RELAT&&TESTL(tree->tr1)) && tree->op!=ITOL)
		{
		reg1--;
#if DEBUG
		dbprt("trc",
		"trc - cexpr found long reducing reg1 to %d\n",reg1) ;
#endif
		}
	/*
	 * Leaves of the expression tree
	 */
	if ((r = chkleaf(tree, table, reg)) >= 0)
		return(r);
	/*
	 * x + (-1) is better done as x-1.
	 */

	if ((tree->op==PLUS||tree->op==ASPLUS) &&
	    (p1=tree->tr2)->op == CON && p1->value == -1) {
		p1->value = 1;
		tree->op =+ (MINUS-PLUS);
	}
	if (table==cregtab)
		table = regtab;
	/* *** not for 8086!!!
	 * The following peculiar code depends on the fact that
	 * if you just want the codition codes set, efftab
	 * will generate the right code unless the operator is
	 * a shift or
	 * postfix ++ or --. Unravelled, if the table is
	 * cctab and the operator is not special, try first
	 * for efftab;  if the table isn't, if the operator is,
	 * or the first match fails, try to match
	 * with the table actually asked for.
	 */
	r = reg;
/*	if (table!=cctab || c==INCAFT || c==DECAFT || TESTL(tree)
	 || (opt = match(tree, efftab, r)) == 0)
*/
	/* special case floating indirects so we can use different operators
	   -Hans Mar 12, 82 */
	c=tree->op;
	if (c == STAR && (tree->type==FLOAT || tree->type==DOUBLE))
		tree->op=FSTAR;
	else
	if (c == STARPLUS && (tree->type==FLOAT || tree->type==DOUBLE))
		tree->op=FSTARPLUS;
	if ((opt=match(tree, table, r, 0))==0)
	{
		tree->op=c;
		return(-1);
	}
	tree->op=c;
	string = opt->tabstring;
#if DEBUG
	dbprt("trc","trc - cexpr match returned string %s\n",string) ;
#endif
	p1 = tree->tr1;
#ifdef DEBUG
	dbprt("tree","tree op %d,type%d,p1 op %d,type %d\n",tree->op,
	tree->type,p1->op,p1->type) ;
#endif
	if (((c=p1->op)==SFCON||c==FCON) && p1->value>0)
	{
		printf(".data\nL%d:", p1->value);
		outfcon(p1->fvalue, c!=FCON);
		printf(".text\n");
		p1->value = -p1->value;
	}
	p2 = 0;
	if (opdope[tree->op]&BINARY) {
		p2 = tree->tr2;
		if ( ((c=p2->op)==SFCON||c==FCON) && p2->value>0)
		{
			printf(".data\nL%d:", p2->value);
			outfcon(p2->fvalue, c!=FCON);
			printf(".text\n");
			p2->value = -p2->value;
		}
	}
		
	r1isbx = r2isbx = regisax = 0;
loop:
	/*
	 * The 0200 bit asks for a tab.
	 */
	if ((c = *string++) & 0200) {
		c =& 0177;
		putchar('\t');
	}
	switch (c) {

	case '\n':
		if (cxpr_debug) printf ("\t| %s %o\n", opntab[tree->op], tree->type);
		break;

	case '\0':
		switch (tree->op) {
		 case CTOL:
		 case ITOL:
		 case FTOL:
		 case UMOD:
		 case ASUMOD:
		 case MOD:
		 case ASMOD:	reg = DX;
				goto cxpr_ret;

		 case ITOC:
		 case LTOC:
		 case TIMES:
		 case ASTIMES:
		 case DIVIDE:
		 case PTOI:
		 case UDIV:
		 case FTOI:
		 case ASUDIV:
		 case ASDIV:	if((tree->type!=DOUBLE) && (tree->type!=FLOAT))
					reg = AX;
				goto cxpr_ret;

/*
		 case STAR:
		 case STARPLUS:
				if (regisax)
				{
					if (tree->type==LONG)
						reg = DX;
					else
						reg = AX;
					goto cxpr_ret;
				}
*/
		 default:	
cxpr_ret:
			if (cxpr_debug) 
			    printf("***cexpr returning %s\n", reg_names[reg]);
#ifdef DEBUG
			dbprt("trc","trc- cexpr returning %s\n",reg_names[reg]);
#endif
			return(reg);
		 };

	/* A1 */
	case 'A':
		p = p1;
		goto adr;

	/* A2 */
	case 'B':
		p = p2;
		goto adr;

	adr:
		c = 0;
/* WHY IS THIS HERE????
		if (TESTL(tree) && p->op==CON) {
		 lp.op = LCON;
		 lp.type = LONG;
		 lp.lvalue = p->value;
		 p = &lp;
		}
*/
		while (*string=='\'') {
			c++;
			string++;
		}
		if (*string=='+') {
			c = 100;
			string++;
		}
		pname(p, c);
		goto loop;

	/* I */
	case 'M':
		if ((c = *string)=='\'')
			string++;
		else
			c = 0;
		prins(tree->op, c, instab);

		/* if we are doing long arithmetic calls,
		   fiddle the register allocator, as runtime will
		   return its result in ax,dx.  The original
		   author of this thing was using 'D' rather
		   than 'd'.  D is the character that is used
		   for B2 function, so the operation IB2 and
		   ID generated the same pattern, and caused
		   a serious register allocation bug in the
		   IB2 case.  -Hans, Dec 9, 1981 */
		if (*string == 'd') {
			reg = DX;
			reg1 = AX;
			string++;
		}
		goto loop;

	/* B1 */
	case 'C':
		p = p1;
		goto pbyte;

	/* BT */
	case 'J':
		p = tree;
		goto pbyte;

	/* BF */
	case 'P':
		p = tree;
		goto pb1;

	/* B2 */
	case 'D':
		p = p2;
	pbyte:
		if (p->type == CHAR)
			putchar('b');
	pb1:
		/*	isfloat walks down the tree for relationals
		if ((c=isfloat(p))>1) putchar('d');
		else if (c>0) putchar ('s');
		*/
#ifdef DEBUG
		dbprt("tree","p->type %d,p->op %d\n",p->type,p->op) ;
#endif
		if (p->type == DOUBLE)
			{
			nfloat = 1;
			putchar('d') ;
			}
		else if (p->type == FLOAT)
			{
			putchar ('s') ;
			nfloat = 1;
			}
		p = tree;
		goto loop;

	/* BE */
	case 'L':
		if (p1->type==CHAR || p2->type==CHAR)
			putchar('b');
		p = tree;
		goto pb1;

	/* F */
	case 'G':
		p = p1;
		flag = 01;
		goto subtre;

	/* S */
	case 'K':
		p = p2;
		flag = 02;
		goto subtre;

	/* H */
	case 'H':
		p = tree;
		flag = 04;

	subtre:
		ctable = regtab;
		if (flag&04)
			ctable = cregtab;
		c = *string++ - 'A';
		if (*string=='!') {
			string++;
			c =| 020;	/* force right register */
		}
		/* converted from 'D' to 'd' 2/12/82.  see note above
		   -Hans */
		if (*string == 'd') {
			string++;
			c |= 040;	/* force into AX */
			reg1 = AX;
			reg = DX;
		}
		if ((c&02)!=0)
			ctable = sptab;
		if ((c&04)!=0)
			ctable = cctab;
		if ((flag&01) && ctable==regtab && (c&01)==0
		  && (tree->op==DIVIDE||tree->op==MOD
		   || tree->op==ASDIV||tree->op==ASMOD))
			ctable = cregtab;
		if ((c&01)!=0) {
			p = p->tr1;
			if (collcon(p, reg))
				p = p->tr1;
		}
		if (c&010)
			r = reg1;
		else
			if (opdope[p->op]&LEAF || p->degree < 2)
				r = reg;
			else
				r = areg;
		/* generate code for the operand. */
		rreg = rcexpr(p, ctable, r);
#ifdef DEBUG
		dbprt("trc",
		"after subtre code c=%o,reg=%d,rreg=%d,r=%d,reg1=%d,flag=%o\n",
		c,reg,rreg,r,reg1,flag) ;
#endif
		if (ctable!=regtab && ctable!=cregtab)
			goto loop;
		if ((c&01) && (c&020) == 0 && rreg != SI && rreg != DI && (r == SI || r == DI)){
				movreg(rreg, r, p);
				rreg = r;
				if (c&010)
					reg1 = rreg;
				else
					reg = rreg;
		}
		if (c&050) {
			if (c&060 && rreg!=reg1)
				movreg(rreg, reg1, p);
			else
				reg1 = rreg;
		} else if (rreg != reg)
			if ((c&020)==0
			/* seems to be showing a bug, so replace this: */
			/* && !(tree->type==LONG && rreg<2) */
			/* with this: */
			&& tree->type!=LONG
			&& !(tree->type == CHAR && rreg >= SI)
			&& (flag&04
			  || flag&01&&xdcalc(p2,rreg-1)<=(opt->tabdeg2&077)
			  || flag&02&&xdcalc(p1,rreg-1)<=(opt->tabdeg1&077))) {
				reg = rreg;
				reg1 = rreg-1;
			}
			else {
				movreg(rreg, reg, p);
				rreg = reg;
			}
		if ((c&01) && rreg!=SI && rreg!=DI) {
			movreg(rreg,BX,p);
			if (c&010) r2isbx++; else r1isbx++;
		}
		goto loop;

	/* PU */
	case 'U':
		if(++fpstack>7)
		    error("Floating point stack overflow; simplify expression");
		goto loop;

	/* PO */
	case 'Q':
		/* note that PO doesnt put out a p because some
		   instructions implicitly do them */
		if(--fpstack<0)
		    error("Floating point stack underflow");
		goto loop;

	/* PP */
	case 'R':
		if (forvalue==0)
		{
		    putchar('p');
		    if (--fpstack<0)
			error("floating point stack underflow");
		}
		goto loop;

	/* R */
	case 'I':
		c = *string++ - 'A';
		if (c&01)
		 { if (c&010) r = r2isbx ? BX:reg1; else r = r1isbx ? BX:reg;
		   goto preg;
		 };
		if (c&010) r = reg1;
		else { r = reg;	if (*string=='-') { string++; r++; } };

	preg:	
		if (*string=='+') {
			string++;
			r--;
		}

		/* print out the final register name */
		printf("%s", reg_names[r]);
		goto loop;

	case 'p':		/* check for changes in the stack level */
		if (strncmp(string,"ush", 3) == 0) nstack++;
		else if (strncmp(string,"op", 2) == 0) nstack--;
		putchar('p');
		goto loop;

	/* #1 */
	case '#':
		if (p1->op == STARPLUS) {
			p = p1;
			if ((p = p->tr2)->op == CON) {
				if (p->value)
					printf("*%d.", p->value);
			} else if (p->op==AMPER)
				pname(p->tr1, 0);
			else
				printf("***");

			p = p1->tr1;
			if (p->op == PLUS || p->op == MINUS) {
				if ((p = p->tr2)->op == CON) {
					if (p->value)
						printf("+%d.", p->value);
				} /* else if (p->op==AMPER)
					pname(p->tr1, 0); */
			}
			goto loop;
		}
		p = p1->tr1;
		goto nmbr;

	/* #2 */
	case '"':
		if (p2->op == STARPLUS) {
			p = p2;
			if ((p = p->tr2)->op == CON) {
				if (p->value)
					printf("*%d.", p->value);
			} else if (p->op==AMPER)
				pname(p->tr1, 0);
			else
				printf("***");

			p = p2->tr1;
			if (p->op == PLUS || p->op == MINUS) {
				if ((p = p->tr2)->op == CON) {
					if (p->value)
						printf("+%d.", p->value);
				} else if (p->op==AMPER)
					pname(p->tr1, 0);
			}
			goto loop;
		}
		p = p2->tr1;

	nmbr:
		if(collcon(p, reg)) {
	pnumb:
			if ((p = p->tr2)->op == CON) {
				if (p->value)
					printf("%c%d.",(p->value>=-128 && p->value<=127)?'*':'',p->value);
			} else if (p->op==AMPER)
				pname(p->tr1, 0);
		}
		goto loop;

	/*
	 * Certain adjustments for / % and PTOI
	 */
	case 'T':
		if (tree->op == PTOI) {
			printf("mov\tdx,*0\nsbb\tdx,*0\n");
			goto loop;
		}
		if (tree->op == ITOC) {
			if(tree->type == INT)
				printf("cbw\n") ;
			goto loop;
			}
		if (tree->op == ITOF) {
			if (reg != AX)
				movreg (reg,AX,p1) ;
			goto loop;
			}
		/* this does not match the white books semantics:
		if (p1->type==UNSIGN || p1->type&XTYPE) {
		    but this does:  -Hans Feb 19, 1982 */
		if ((tree->type==UNSIGN || tree->type&XTYPE)
		    && (!TESTL(p1)))
		{
			printf("sub	dx,dx\n");
			goto loop;
		}
		printf("cwd\n");
		goto loop;

	case 'V':	/* adc sbc, clr, or sxt as required for longs */
		/* note that we must do this for floating point ops too,
		   even though there is no code to be generated, because
		   V is used to make sure the index register a legal index
		   register when we are not generating with F*.  ...Well,
		   It might generate a mov..  -Hans, Mar 15, 82 */
		switch(tree->op) {
		case STARPLUS:
		case STAR:
			/* added test for r1isbx so we dont
			   do this twice -Hans, Feb 23, 82 */
			if (!r1isbx && reg!=SI && reg!=DI)
				{ movreg(reg,BX,p); r1isbx++; }
			if (TESTL(tree)) {
				/* cant do a long in only one register 
				   -Hans, Mar 12, 82 */
				if (reg==AX) reg = DX;

				printf("mov");
				break;
			}
			goto eatit;

		case PLUS:
		case ASPLUS:
		case INCBEF:
		case INCAFT:
			printf("adc");
			break;

		case MINUS:
		case ASMINUS:
		case NEG:
		case DECBEF:
		case DECAFT:
			printf("sbb");
			break;

		case AND:
		case ASAND:
		case OR:
		case ASOR:
		case EXOR:
		case ASXOR:
		case ASSIGN:
			prins(tree->op, 0, instab);
			break;

		case ASDIV:
		case ASMOD:
		case ASULSH:
			p = tree->tr1;
		lcasev:
			if (!TESTL(p)) {
				if (p->type==UNSIGN || p->type&XTYPE)
					printf("sub	dx,dx");
				else
					printf("cwd");
				goto loop;
			}
		default:
eatit:
			while ((c = *string++)!='\n' && c!='\0');
			break;
		}
		goto loop;

	/*
	 * Mask used in field assignments
	 */
	case 'Z':
		r = ~tree->mask;
		printf("%c/%x",(r>=-128 && r<=127? '*':'#'),r);
		goto loop;

	/*
	 * Relational on long values.
	 * Might bug out early. E.g.,
	 * (long<0) can be determined with only 1 test.
	 */
	case 'X':
		if (xlongrel(*string++ - '0'))
			return(reg);
		goto loop;
	case 'S':			/* print # symbol */
		printf("#") ;
		goto loop ;
	}
	putchar(c);
	goto loop;
}

/*
 * This routine just calls sreorder (below)
 * on the subtrees and then on the tree itself.
 * It returns non-zero if anything changed.
 */
reorder(treep, table, reg)
struct tnode **treep;
struct table *table;
{
	register r, o;
	register struct tnode *p;

	p = *treep;
	o = p->op;
	if (opdope[o]&LEAF || o==LOGOR || o==LOGAND)
		return(0);
	while(sreorder(&p->tr1, regtab, reg, 1))
		;
	if (opdope[o]&BINARY) 
		while(sreorder(&p->tr2, regtab, reg, 1))
			;
	r = 0;
	if (table!=cctab)
	while (sreorder(treep, table, reg, 0))
		r++;
	*treep = optim(*treep);
	return(r);
}

/*
 * Basically this routine carries out two kinds of optimization.
 * First, it observes that "x + (reg = y)" where actually
 * the = is any assignment op is better done as "reg=y; x+reg".
 * In this case rcexpr is called to do the first part and the
 * tree is modified so the name of the register
 * replaces the assignment.
 * Moreover, expressions like "reg = x+y" are best done as
 * "reg = x; reg =+ y" (so long as "reg" and "y" are not the same!).
 */
sreorder(treep, table, reg, recurf)
struct tnode **treep;
struct table *table;
{
	register struct tnode *p, *p1;

	p = *treep;
	if (opdope[p->op]&LEAF)
		return(0);
	if (p->op==PLUS && recurf)
		if (reorder(&p->tr2, table, reg))
			*treep = p = optim(p);
	p1 = p->tr1;
	if (p->op==STAR || p->op==PLUS) {
		if (recurf && reorder(&p->tr1, table, reg))
			*treep = p = optim(p);
		p1 = p->tr1;
	}
	if (p1->op==NAME) switch(p->op) {
		case ASLSH:
		case ASRSH:
		case ASSIGN:
			if (p1->class != REG||p1->type==CHAR||isfloat(p->tr2))
				return(0);
			if (p->op==ASSIGN) switch (p->tr2->op) {
			case TIMES:
				if (!ispow2(p->tr2))
					break;
				p->tr2 = pow2(p->tr2);
			case PLUS:
			case MINUS:
			case AND:
			case ANDN:
			case OR:
			case EXOR:
			case LSHIFT:
			case RSHIFT:
				p1 = p->tr2->tr2;
				if (xdcalc(p1, 16) > 12
				 || p1->op==NAME
				 &&(p1->nloc==p->tr1->nloc
				  || p1->regno==p->tr1->nloc))
					return(0);
				p1 = p->tr2;
				p->tr2 = p1->tr1;
				if (p1->tr1->op!=NAME
				 || p1->tr1->class!=REG
				 || p1->tr1->nloc!=p->tr1->nloc)
					rcexpr(p, efftab, reg);
				p->tr2 = p1->tr2;
				p->op = p1->op + ASPLUS - PLUS;
				*treep = p;
				return(1);
			}
			goto OK;

		case ASTIMES:
			if (!ispow2(p))
				return(0);
		case ASPLUS:
		case ASMINUS:
		case ASAND:
		case ASANDN:
		case ASOR:
		case ASXOR:
		case INCBEF:
		case DECBEF:
		OK:
			if (table==cctab||table==cregtab)
				reg =+ 020;
			rcexpr(optim(p), efftab, ~reg);
			*treep = p1;
			return(1);
	}
	return(0);
}

/*
 * Delay handles postfix ++ and -- 
 * It observes that "x + y++" is better
 * treated as "x + y; y++".
 * If the operator is ++ or -- itself,
 * it calls rcexpr to load the operand, letting
 * the calling instance of rcexpr to do the
 * ++ using efftab.
 * Otherwise it uses sdelay to search for inc/dec
 * among the operands.
 */
delay(treep, table, reg)
struct tnode **treep;
{
	register struct tnode *p, *p1;
	register r;

	p = *treep;
	if (dela_debug) {printf ("**delay**\n");
			 dtree(p, 0);}
	if (p->type==FLOAT||p->type==DOUBLE) return(0);
	if ((p->op==INCAFT||p->op==DECAFT)
	 && p->tr1->op==NAME) {
		return(1+rcexpr(p->tr1, table, reg));
	}
	p1 = 0;
	if (opdope[p->op]&BINARY) {
		if (p->op==LOGAND || p->op==LOGOR)
			return(0);
		/* the '}' below was once here.  -Hans 12 13 81 */
		p1 = sdelay(&p->tr2);
	}
	if (p1==0)
		p1 = sdelay(&p->tr1);
	if (p1) {
		r = rcexpr(optim(p), table, reg);
		*treep = p1;
		return(r+1);
	}
	return(0);
}

sdelay(ap)
struct tnode **ap;
{
	register struct tnode *p, *p1;

	p = *ap;
	if ((p->op==INCAFT||p->op==DECAFT) && p->tr1->op==NAME) {
		*ap = ncopy(p->tr1);
		return(p);
	}
	if (p->op==STAR || p->op==PLUS)
		if (p1=sdelay(&p->tr1))
			return(p1);
	if (p->op==PLUS)
		return(sdelay(&p->tr2));
	return(0);
}

/*
 * Copy a tree node for a register variable.
 * Used by sdelay because if *reg-- is turned
 * into *reg; reg-- the *reg will in turn
 * be changed to some offset class, accidentally
 * modifying the reg--.
 */
ncopy(ap)
struct tname *ap;
{
	register struct tname *p, *q;

	p = ap;
	if (p->class!=REG)
		return(p);
	q = getblk(sizeof(*p));
	q->op = p->op;
	q->type = p->type;
	q->class = p->class;
	q->offset = p->offset;
	q->nloc = p->nloc;
	return(q);
}

/*
 * If the tree can be immediately loaded into a register,
 * produce code to do so and return success.
 */
chkleaf(atree, table, reg)
struct tnode *atree;
{
	struct tnode lbuf;
	register struct tnode *tree;

	tree = atree;
#ifdef INTERMED
	if (/* tree->op!=STAR && */ dcalc(tree,reg) > 16)
#else
	if (/* tree->op!=STAR && */ dcalc(tree,reg) > 12)
#endif
		return(-1);
	lbuf.op = LOAD;
	lbuf.type = tree->type;
	lbuf.degree = tree->degree;
	lbuf.tr1 = tree;
#if DEBUG
	dbprt("trc","trc - chkleaf makeing LOAD op,type %x,degree %x\n",
	tree->type,tree->degree) ;
#endif
	return(rcexpr(&lbuf, table, reg));
}

/*
 * Compile a function argument.
 * Return the number of bytes pushed,
 * for future popping.
 * If type is CHAR, make it into an int before pushing it!
 */
comarg(atree, reg)
{
	register struct tnode *tree;
	register retval;
	int i;
	int size;

	tree = atree;
#if DEBUG
	dbprt("trc","trc comarg op %d,type %x,reg %d\n",
	tree->op,tree->type,reg);
#endif
	if (tree->op==STRASG) {
		size = tree->mask;
		tree = tree->tr1;
		tree = strfunc(tree);
		if (size <= 2) {
			setype(tree, INT);
			goto normal;
		}
		if (size <= 4) {
			setype(tree, LONG);
			goto normal;
		}
		if (tree->op!=NAME && tree->op!=STAR) {
			error("Unimplemented structure assignment");
			return(0);
		}
		tree = tnode(AMPER, STRUCT+PTR, tree);
		tree = tnode(PLUS, STRUCT+PTR, tree, tconst(size, INT));
		tree = optim(tree);
		retval = rcexpr(tree, regtab, reg);
/* we are doing structure pushes.  why do floating point? -Hans Mar 21, 1983*/
#ifdef WHATISTHISHEREFOR
		if (tree->type==DOUBLE || tree->type==FLOAT)
		{
#ifdef INTERMED
#ifdef IEEE
			printf("sub\tsp,*8\nxchg\tax,si\nmov\tsi,sp\nfstdp\t(si)\nfwait\nxchg\tax,si\n");
#else
			printf("sub\tsp,*8\nmov\tax,sp\ncalli\tfstdp\n");
#endif
#else
#ifdef IEEE
			printf("sub\tsp,*8\nxchg\tax,si\nmov\tsi,sp\nfstdp\t(si)\nfwait\nxchg\tax,si\n");
#else
			printf("sub\tsp,*8\nmov\tax,sp\ncall\tfstdp\n");
#endif
#endif
			fpstack--;
			nstack+=4;
		}
		else
#endif WHATISTHISHEREFOR
		{
			size =>> 1;
			printf("mov	bx,%s\n", reg_names[retval]);
			if (size <= 2) {
				for (i=0; i<size; i++)
					printf("\tpush	*0(bx)\n\tsub	bx,*2\n");
			} else {
				printf("mov	cx,*%d.\n", size);
				printf("L%d:\tsub\tbx,*2.\npush\t(bx)\nloop\tL%d\n", isn, isn);
				isn++;
			}
		nstack++;
		}
		return(size*2);
	}
normal:
	if (tree->type == CHAR) tree = tnode(ITOC, INT, tree);
	forvalue++;  /* incase of imbedded assignment.  -Hans, Mar 21, 83 */
	rcexpr(tree, sptab, reg);
	forvalue--;
	retval = arlength(tree->type);
	return(retval);
}

struct tnode *
strfunc(atp)
struct tnode *atp;
{
	register struct tnode *tp;

#ifdef DEBUG
	dbprt("trc","trc - strfunc op %d\n",atp->op) ;
#endif
	tp = atp;
	if (tp->op != CALL && tp->op != CALLSTAR)
		return(tp);
	setype(tp, STRUCT+PTR);
	return(tnode(STAR, STRUCT, tp));
}

/*
 * Compile an initializing expression
 */
doinit(atype, atree)
struct tnode *atree;
{
	register struct tnode *tree;
	register int type;
	float sfval;
	double fval;
	long lval;

	tree = atree;
	type = atype;
#if DEBUG
	dbprt("trc","trc - doinit type %x,tree op %d\n",type,tree->op) ;
#endif
	if (type==CHAR) {
		printf(".byte ");
		if (tree->type&XTYPE)
			goto illinit;
		type = INT;
	}
#ifdef INTERMED
	if ((type&XTYPE) == LPTR)
		type = LONG ;
	else 
#endif
	if (type&XTYPE)
		type = INT;
	switch (type) {
	case INT:
	case UNSIGN:
		if (tree->op==FTOI) {
			if (tree->tr1->op!=FCON && tree->tr1->op!=SFCON)
				goto illinit;
			tree = tree->tr1;
			tree->value = tree->fvalue;
			tree->op = CON;
		} else
		if (tree->op==LTOI) {
			if (tree->tr1->op!=LCON)
				goto illinit;
			tree = tree->tr1;
			lval = tree->lvalue;
			tree->op = CON;
			tree->value = lval;
		}
		if (tree->op == CON)
			printf("/%x\n", tree->value);
		else if (tree->op==AMPER) {
			if (tree->tr1->class==OFFS)
				goto illinit;
			printf("\t");
			pname(tree->tr1, 0);
			putchar('\n');
		} else
			goto illinit;
		return;

	case DOUBLE:
	case FLOAT:
		if (tree->op==ITOF) {
			if (tree->tr1->op==CON) {
				fval = tree->tr1->value;
			} else
				goto illinit;
		} else if (tree->op==FCON || tree->op==SFCON)
			fval = tree->fvalue;
		else if (tree->op==LTOF) {
			if (tree->tr1->op!=LCON)
				goto illinit;
			fval = tree->tr1->lvalue;
		} else
			goto illinit;
		outfcon(fval, type==FLOAT);
		return;

	case LONG:
		if (tree->op==FTOL) {
			tree = tree->tr1;
			if (tree->op==SFCON)
				tree->op = FCON;
			if (tree->op!= FCON)
				goto illinit;
			lval = tree->fvalue;
		} else 
		if (tree->op==ITOL) {
			if (tree->tr1->op != CON)
				goto illinit;
			lval = tree->tr1->value;
		} else if (tree->op==LCON)
			lval = tree->lvalue;
#ifdef INTERMED
		else if (tree->op==AMPER)
			{
			printf(".dlptr\t") ;
			pname(tree->tr1,0) ;
			putchar('\n') ;
			return;
			}
#endif
		else
			goto illinit;
		printf("\t.word\t/%x,/%x\n", lval);
		return;
	}
illinit:
	error("Illegal initialization");
}

movreg(r0, r1, tree)
struct tnode *tree;
{
	register char *s;

	if (r0==r1)
		return;
#ifdef DEBUG
	dbprt("trc","trc - movreg %d to %d, tree op %d\n",r0,r1,tree->op) ;
#endif
	if (TESTL(tree))
		{
		s = "mov	%s,%s\nmov	%s,%s\n";
		if (r0 > r1)
			printf(s, reg_names[r1-1],reg_names[r0-1],reg_names[r1],reg_names[r0]);
		else
			printf(s, reg_names[r1],reg_names[r0],reg_names[r1-1],reg_names[r0-1]);
		return;
	}
	printf("mov	%s,%s\n",reg_names[r1],reg_names[r0]);
}

outfcon(fval, type)
double fval;
{
	float sfval;
	if (type)
	{
		sfval = fval;
#ifdef FCONWARN
		warn("single precision floating point constant\n") ;
#endif
		printf("\t.float\t%.17e\n",sfval) ;
	}
	else
	{
#ifdef FCONWARN
		warn("double precision floating point constant\n") ;
#endif
		printf("\t.double\t%.17e\n",fval) ;
	}
}
