/*
 * Copyright (C) Microsoft Corporation, 1982
 */

/*
 * Header for object code improver
 */

#include <stdio.h>

#define	JBR	1
#define	CBR	2
#define	JMP	3
#define	LABEL	4
#define	DLABEL	5
#define POP	6
#define	EROU	7
#define PUSH	8
#define	JSW	9
#define	MOV	10
#define	AND	11
#define	OR	12
#define	INC	13
#define	DEC	14
#define	NEG	15
#define	TEST	16
#define SBR	17
#define SB	18
#define	CWD	19
#define	CMP	20
#define	ADD	21
#define	SUB	22
#define	MUL	26
#define	DIV	27
#define	XOR	29
#define	TEXT	30
#define	DATA	31
#define	BSS	32
#define	EVEN	33
#define SAL	34
#define REGVAR	46
#define	CALL	47
#define	END	48
#define NOP	49
#define RET	50
#define NOT	51
#define XCHG	53
#define CBW	54
#define LEA	55
#define ADC	56
#define SBB	57
#define LOOP	58
#define SEG		59
#define UDIV	60
#define	SAR		61
#define	SHR		62
#define RETYPE	63
#define FLOAT	64
#define FWAIT	65
#ifdef INTERMED
#define JMPI	66
#endif

#define	JEQ	0
#define	JNE	1
#define	JLE	2
#define	JGE	3
#define	JLT	4
#define	JGT	5
#define	JLO	6
#define	JHI	7
#define	JLOS	8
#define	JHIS	9

#define	BYTE	100
#define	LSIZE	512

struct node {
	char	op;
	char	subop;
	struct	node	*forw;
	struct	node	*back;
	struct	node	*ref;
	int	labno;
	char	*code;
	int	refc;
	char	regused;
	char	regset;
};

struct optab {
	char	*opstring;
	int	opcode;
} optab[];

char	line[LSIZE];
struct	node	first;
char	*curlp;
int	nbrbr;
int	nsaddr;
int	redunm;
int	iaftbr;
int	njp1;
int	nrlab;
int	nxjump;
int	ncmot;
int	nrevbr;
int	loopiv;
int	nredunj;
int	nskip;
int	ncomj;
int	nsob;
int	nrtst;
int	nlit;
int	npush;
int	npop;
int	n_ors;
int	nsbr;

int	nchange;
int	regvar;
int	isn;
int	debug;
int	lastseg;
char	*lasta;
char	*lastr;
char	*firstr;
char	revbr[];
char    regs[15][32];
char    conloc[32];
char    conval[32];
char    ccloc[32];

#define	RT1	12
#define	RT2	13
#define RT3	14
#define	NREG	6
#define RBP	6
#define	LABHS	127
#define	OPHS	79
#define LONG	6	/* value of long type */

struct optab *ophash[OPHS];
struct	node *nonlab();
char	*copy();
char	*sbrk();
char	*findcon();
struct	node *insertl();
struct	node *codemove();
char	*sbrk();
char	*alloc();
