/*
/* Copyright (C) Microsoft Corporation, 1982
/*
/*
/ c code tables-- compile to register
/
/ it is	important that there be	no capital letters, colons,
/ sharp	signs, or percent signs	in comments,
/ as cvopt blindly interprets them.
/

.globl	_regtab

.data
_regtab:
	106.;	cr106		/ load
	123.;	cr123		/ floating *
	36.;	cr36		/ *
	30.;	cr30		/ ++x
	31.;	cr30		/ --x
	32.;	cr32		/ x++
	33.;	cr32		/ x--
	37.;	cr37		/ -x
	38.;	cr37		/ ~x
	98.;	cr98		/ call *x
	99.;	cr100		/ call
	80.;	cr80		/ =
	40.;	cr40		/ +
	41.;	cr40		/ - like +
	42.;	cr42		/ * (times)
	43.;	cr43		/ /
	14.;	cr43		/ ptoi
	44.;	cr43		/ mod
	45.;	cr45		/ >>
	46.;	cr46		/ <<
	47.;	cr47		/ and
	48.;	cr47		/ or
	49.;	cr47		/ exor
	70.;	cr70		/ +=
	71.;	cr71		/ -=
	72.;	cr72		/ *=
	73.;	cr73		/ /=
	74.;	cr74		/ mod=
	75.;	cr75		/ >>=
	76.;	cr76		/ <<=
	77.;	cr70		/ ^=
	78.;	cr70		/ |=
	79.;	cr70		/ ^=
	102.;	cr102		/ jump
	51.;	cr51		/ itof
	52.;	cr52		/ ftoi
	56.;	cr56		/ ftol
	57.;	cr57		/ ltof
	58.;	cr58		/ itol
	59.;	cr59		/ ltoi
	91.;	cr45		/ long <<
	82.;	cr82		/ long *
	83.;	cr82		/ long /
	84.;	cr82		/ long mod
	86.;	cr86		/ long *=
	87.;	cr86		/ long /=
	88.;	cr86		/ long mod=
	16.;	cr16		/ field	assign
	92.;	cr76		/ long <<=
	17.;	cr45		/ unsigned >>
	18.;	cr75
	107.;	cr107		/ ctol
	108.;	cr108		/ ltoc
	109.;	cr109		/ itoc
	89.;	cr89		/ starplus
	122.;	cr122		/ floating starplus
	117.;	cr43		/ udiv
	118.;	cr73		/ asudiv
	119.;	cr43		/ umod
	120.;	cr74		/ asumod
	0

.data
/ goto
cr102:
%a,n
	jmp	A1

%n,n
	F*
	jmp	@R

%n*,n
	F*
	jmp	@#1(R*)

/ call
cr100:
SF#%a,n
SF#	call	A1
SF#
IX#%alp,n
IX#	calli	A1
IX#
/ callstar
cr98:
S#%r,n
S#	call	A1
S#
S#%a,n
S#	.segrel
S#	call	@A1
S#
S#%n*,n
S#	F*
S#	call	@#1(R*)
S#
S#%n,n
S#	F
S#	call	R
S#
F#%r,n
F#	call	A1
F#
F#%a,n
F#	.segrel
F#	call	@A1
F#
F#%n*,n
F#	F*
F#	call	@#1(R*)
F#
F#%n,n
F#	F
F#	call	R
F#
IX#%alp,n
IX#	calli	@A1
IX#
IX#%nlp*,n
IX#	F*
IX#	calli	@#1(R*)
IX#
IX#%nlp,n
IX#	F
IX#	mov	caltmp,R
IX#	mov	caltmp+2,R+
IX#	calli	@caltmp
IX#
/starplus (special case)
cr89:
%n,c
	F
	V	R+,A2 +2(R*)
	movBT	R,A2(R*)

%n*,c
	F*
	mov	R*,#1(R*)
	V	R+,A2 +2(R*)
	movBT	R,A2(R*)

/ floating starplus
cr122:
%n,c
	F
	V
S#	lea	ax,A2(R*)
S#	call	fldBTPU
I#	lea	ax,A2(R*)
I#	calli	fldBTPU
FX#	fldBTPU	A2(R*)
FX#	fwait

/ unary	* (indirection)
cr36:

%n,n
	F
	V	R+,*2(R*)
	movBT	R,(R*)

%n*,n
	F*
	mov	R*,#1(R*)
	V	R+,*2(R*)
	movBT	R,(R*)

/ floating unary *
cr123:
%n,n
	F
	V
S#	lea	ax,(R*)
S#	call	fldBTPU
I#	lea	ax,(R*)
I#	calli	fldBTPU
FX#	fldBTPU	(R*)
FX#	fwait

/ addressable (load)
cr106:

%a,n
	movB1	R,A1

%n*,n
	F*
	movB1	R,#1(R*)

%al,n
IX#%alp,n
	mov	R+,A1+
	mov	R,A1

%nl*,n
	F*
	mov	R+,#1+2(R*)
	mov	R,#1(R*)

%af,n
%ad,n
S#	lea	ax,A1
S#	call	fldB1PU
I#	lea	ax,A1
I#	calli	fldB1PU
FX#	fldB1PU	A1
FX#	fwait

%nf*,n
%nd*,n
	F*
S#	lea	ax,#1(R*)
S#	call	fldB1PU
I#	lea	ax,#1(R*)
I#	calli	fldB1PU
FX#	fldB1PU	#1(R*)
FX#	fwait

/ prefix ++,--
cr30:
%a,1
	I'B1	A1
	movB1	R,A1

%a,c
	IB1	A1,A2
	mov	R,A1

%e*,1
	F1*
	I'B1	#1(R1*)
	movB1	R,#1(R1*)

%n*,1
	F*
	I'B1	#1(R*)
	movB1	R,#1(R*)

%e*,c
	F1*
	IB1	#1(R1*),A2
	movB1	R,#1(R1*)

%n*,c
	F*
	IB1	#1(R*),A2
	movB1	R,#1(R*)

%al,1
	I	A1+,*1
	V	A1,*0
	F

%el*,1
	F1*
	I	#1+2(R1*),*1
	V	#1(R1*),*0
	mov	R+,#1+2(R1*)
	mov	R,#1(R1*)

%nl*,1
	F*
	I	#1+2(R*),*1
	V	#1(R*),*0
	mov	R+,#1+2(R*)
	mov	R,#1(R*)

%af,af
%ad,ad
S#	lea	ax,A1
S#	call	fldB1PU
S#	lea	ax,A2
S#	call	fIB2
S#	lea	ax,A1
S#	call	fstB1PP
I#	lea	ax,A1
I#	calli	fldB1PU
I#	lea	ax,A2
I#	calli	fIB2
I#	lea	ax,A1
I#	calli	fstB1PP
F#	fldB1PU	A1
F#	fIB2	A2
F#	fstB1PP	A1
F#	fwait
X#	fldB1PU	A1
X#	fIB2	A2
X#	fstB1PP	A1
X#	fwait

/ dont optimize across the comment!
%nf*,af
%nd*,ad
	F*
S#	lea	ax,#1(R*)
I#	lea	ax,#1(R*)
S#|
I#|
S#	push	ax
S#	call	fldB1PU
S#	lea	ax,A2
S#	call	fIB2
S#	pop	ax
S#	call	fstB1PP
I#	push	ax
I#	calli	fldB1PU
I#	lea	ax,A2
I#	calli	fIB2
I#	pop	ax
I#	calli	fstB1PP
F#	fldB1PU	#1(R*)
F#	fIB2	A2
F#	fstB1PP	#1(R*)
F#	fwait
X#	fldB1PU	#1(R*)
X#	fIB2	A2
X#	fstB1PP	#1(R*)
X#	fwait

/ ++,--	postfix
cr32:
%a,1
	movB1	R,A1
	I'B1	A1

%a,c
	mov	R,A1
	IB1	A1,A2

%e*,1
	F1*
	movB1	R,#1(R1*)
	I'B1	#1(R1*)

%n*,1
	F*
	push	#1(R*)
	I'B1	#1(R*)
	pop	R

%e*,c
	F1*
	movB1	R,#1(R1*)
	IB1	#1(R1*),A2

%n*,c
	F*
	push	#1(R*)
	IB1	#1(R*),A2
	pop	R

%al,1
	F
	I	A1+,*1
	V	A1,*0

%el*,1
	F1*
	mov	R+,#1+2(R1*)
	mov	R,#1(R1*)
	I	#1+2(R1*),*1
	V	#1(R1*),*0

%nl*,1
	F*
	push	#1+2(R*)
	push	#1(R*)
	I	#1+2(R*),*1
	V	#1(R*),*0
	pop	R
	pop	R+

%af,af
%ad,ad
IS#	lea	ax,A1
S#	call	fldB1PU
I#	calli	fldB1PU
S#	call	fdupPU
I#	calli	fdupPU
IS#	lea	ax,A2
S#	call	fIB2
I#	calli	fIB2
IS#	lea	ax,A1
S#	call	fstB1pPO
I#	calli	fstB1pPO
FX#	fldB1PU	A1
FX#	fldPU	st(0)
FX#	fIB2	A2
FX#	fstB1pPO	A1
FX#	fwait

/ dont optimize across the comment
%nf*,af
%nd*,ad
	F*
IS#	lea	ax,#1(R*)
IS#|
IS#	push	ax
S#	call	fldB1PU
I#	calli	fldB1PU
S#	call	fdupPU
I#	calli	fdupPU
IS#	lea	ax,A2
S#	call	fIB2
I#	calli	fIB2
IS#	pop	ax
S#	call	fstB1pPO
I#	calli	fstB1pPO
FX#	fldB1PU	#1(R*)
FX#	fldPU	st(0)
FX#	fIB2	A2
FX#	fldB1pPO	#1(R*)
FX#	fwait

/ - unary, ~
cr37:
%n,n
	F
	IB1	R

%nl,n
	F
	I	R
	I	R+
	V	R,*0

%nf,n
%nd,n
	F
S#	call	fI
I#	calli	fI
F#	fchs
X#	fchs

/ =
cr80:
%a,n
	S
	movB1	A1,R

%nw*,rw
%nb*,rb
	F*
	movB1	#1(R*),A2
	movB1	R,A2

%ew*,nw
%eb*,nb
	S!
	F1*
	movB1	#1(R1*),R

%nw*,nw
%nb*,nb
%nb*,nw
	FS*
	S
	pop	bx
	movB1	#1(bx),R

%al,nl
I#%alp,nlp
I#%al,nlp
I#%alp,nl
X#%alp,nlp
X#%al,nlp
X#%alp,nl
	S
	mov	A1+,R+
	mov	A1,R

%el*,nl
I#%el*,nlp
I#%elp*,nl
I#%elp*,nlp
X#%el*,nlp
X#%elp*,nl
X#%elp*,nlp
	S!
	F1*
	mov	#1+2(R1*),R+
	mov	#1(R1*),R

%nl*,nl
I#%nl*,nlp
I#%nlp*,nlp
I#%nlp*,nl
X#%nl*,nlp
X#%nlp*,nlp
X#%nlp*,nl
	FS*
	S
	pop	bx
	mov	#1(bx),R
	mov	#1+2(bx),R+

%af,nf
%ad,nd
	S
S#	lea	ax,A1
S#	call	fstB1PP
I#	lea	ax,A1
I#	calli	fstB1PP
F#	fstB1PP	A1
F#	fwait
X#	fstB1PP	A1
X#	fwait

%nf*,nf
%nd*,nd
	S
	F*
S#	lea	ax,#1(R*)
S#	call	fstB1PP
I#	lea	ax,#1(R*)
I#	calli	fstB1PP
F#	fstB1PP	#1(R*)
F#	fwait
X#	fstB1PP	#1(R*)
X#	fwait

/ field	assign,	value in reg.
cr16:
%a,n
	S
	andB1	A1,Z
	orB1	A1,R

%e*,n
%	[fas1]

%n*,n
	SS
	F*
	andB1	#1(R*),Z
	pop	bx
	orB1	#1(R*),bx
	mov	R,bx

/ +, -
cr40:
%n,z
	F

%n,1
	F
	I'BT	R

%[addc:]
%nw,c
%nb,c
	F
	IB2	R,A2

%[add1:]
%nw,aw
%nb,ab
	F
	IB2	R,A2

%[add2:]
%nw,ew*
%nb,eb*
	F
	S1*
	IB2	R,#2(R1*)

%[add3:]
%nw,ew
%nb,eb
	F
	S1
	I	R,R1

%[add4:]
%nw,nw*
%nb,nb*
	SS*
	F
	pop	bx
	IB2	R,#2(bx)

%[add5:]
%nw,nw
%nb,nb
	SS
	F
	pop	bx
	IB2	R,bx

%nl,au
I#%nlp,au
X#%nlp,au
	F
	I	R+,A2
	V	R,*0

%nl,eu
I#%nlp,eu
X#%nlp,eu
	F
	S1
	I	R+,R1
	V	R,*0

%[addl0:]
%nl,al
I#%nlp,al
I#%nl,alp
X#%nlp,al
X#%nl,alp
	F
	I	R+,A2+
	V	R,A2

%[addl1:]
%nl,el
I#%nlp,el
I#%nl,elp
X#%nlp,el
X#%nl,elp
	F
	S1
	I	R+,R1+
	V	R,R1

%[addl2:]
%nl,nl
I#%nl,nlp
I#%nlp,nl
X#%nl,nlp
X#%nlp,nl
	SS
	F
	pop	bx
	pop cx
	I	R+,cx
	V	R,bx

%nf,af
%nd,ad
	F
S#	lea	ax,A2
S#	call	fIB2
I#	lea	ax,A2
I#	calli	fIB2
F#	fIB2	A2
F#	fwait
X#	fIB2	A2
X#	fwait

%nf,nf*
%nd,nd*
	F
	S*
S#	lea	ax,#2(R2*)
S#	call	fIB2
I#	lea	ax,#2(R2*)
I#	calli	fIB2
F#	fIB2	#2(R2*)
F#	fwait
X#	fIB2	#2(R2*)
X#	fwait

%nf,nf
%nd,nd
	F
	S
S#	call	fIPO
I#	calli	fIPO
F#	fIPO
X#	fIPO

/ &, |,	^
cr47:
%nw,c
%nb,c
%	[addc]

%nw,aw
%nb,ab
%	[add1]

%nw,ew*
%nb,eb*
%	[add2]

%nw,ew
%nb,eb
%	[add3]

%nw,nw*
%nb,nb*
%	[add4]

%nw,n
%nb,n
%	[add5]

%nl,al
%	[addl0]

%nl,el
%	[addl1]

%nl,nl
%	[addl2]

/ >>, unsigned >>
cr45:
%[shift0:]
%n,z
	F
	| shift of 0 removed

%[shift1:]
%n,1
	F
	IB1	R,*1

%[shift2:]
%n,a
	F
	movB2	cx,A2
	IB1	R,cl

%[shift3:]
%n,e
	F
	S1
	movB2	cx,R1
	IB1	R,cl

%[shift4:]
%n,ew*
	F
	S1*
	movB2	cx,#2(R1*)
	IB1	R,cl

%[shift5:]
%n,n
	SS
	F
	pop	cx
	IB1	R,cl

%nl,z
	F
	| shift	0 of long removed

%nl,1
	F
	I	R,*1
	I'	R+,*1

%nl,c
	F
	mov	cx,A2
	I	R,*1
	I'	R+,*1
	loop	.-4

%nl,a
	F
	mov	cx,A2
	or	cx,cx
	jz	.+8
	I	R,*1
	I'	R+,*1
	loop	.-4

%nl,e
	F
	S1
	mov	cx,R1
	or	cx,cx
	jz	.+8
	I	R,*1
	I'	R+,*1
	loop	.-4

%nl,ew*
	F
	S1*
	mov	cx,#2(R1*)
	or	cx,cx
	jz	.+8
	I	R,*1
	I'	R+,*1
	loop	.-4

%nl,n
	SS
	F
	pop	cx
	or	cx,cx
	jz	.+8
	I	R,*1
	I'	R+,*1
	loop	.-4

%nl,nl
	SS
	F
	pop	cx
	or	cx,cx
	jz	.+8.
	I	R,*1
	I'	R+,*1
	loop	.-4
	pop	cx

/ <<
cr46:
%n,z
%	[shift0]

%n,1
%	[shift1]

%n,a
%	[shift2]

%n,e
%	[shift3]

%n,e*
%	[shift4]

%n,n
%	[shift5]

%nl,z
	F
	| shift	0 of long removed

%nl,1
	F
	I	R+,*1
	I'	R,*1

%nl,c
	F
	mov	cx,A2
	I	R+,*1
	I'	R,*1
	loop	.-4

%nl,a
	F
	mov	cx,A2
	or	cx,cx
	jz	.+8
	I	R+,*1
	I'	R,*1
	loop	.-4

%nl,e
	F
	S1
	mov	cx,R1
	or	cx,cx
	jz	.+8
	I	R+,*1
	I'	R,*1
	loop	.-4

%nl,ew*
	F
	S1*
	mov	cx,#2(R1*)
	or	cx,cx
	jz	.+8
	I	R+,*1
	I'	R,*1
	loop	.-4

%nl,n
	SS
	F
	pop	cx
	or	cx,cx
	jz	.+8
	I	R+,*1
	I'	R,*1
	loop	.-4

%nl,nl
	SS
	F
	pop	cx
	or	cx,cx
	jz	.+8.
	I	R+,*1
	I'	R,*1
	loop	.-4
	pop	cx

/ * -- ax and cx are assumed to	be free
cr42:
%aw,rw
%ab,rb
	movB1	ax,A1
	movB2	cx,A2
	IBE	cx

%nw*,rw
%nb*,rb
	F*
	movB1	ax,#1(R*)
	movB2	cx,A2
	IBE	cx

%nw,rw
%nb,rb
	F
	movB1	ax,R
	movB2	cx,A2
	IBE	cx

%aw,aw
%ab,ab
	movBE	ax,A1
	IBE	A2

%nw*,aw
%nb*,ab
	F*
	movBE	ax,#1(R*)
	IBE	A2

%nw,aw
%nb,ab
	F
	movBE	ax,R
	IBE	A2

%nw,ew*
%nb,eb*
	F
	S1*
	movBE	ax,R
	IBE	#2(R1*)

%nw,nw
%nb,nb
	SS
	F
	movBE	ax,R
	pop	cx
	IBE	cx

%nf,af
%nd,ad
	F
S#	lea	ax,A2
S#	call	fmulB2
I#	lea	ax,A2
I#	calli	fmulB2
F#	fmulB2	A2
F#	fwait
X#	fmulB2	A2
X#	fwait

%nf,nf*
%nd,nd*
	F
	S*
S#	lea	ax,#2(R2*)
S#	call	fmulB2
I#	lea	ax,#2(R2*)
I#	calli	fmulB2
F#	fmulB2	#2(R2*)
F#	fwait
X#	fmulB2	#2(R2*)
X#	fwait

%nf,nf
%nd,nd
	F
	S
S#	call	fmulPO
I#	calli	fmulPO
F#	fmulPO
F#	fwait
X#	fmulPO
X#	fwait


/ /, mod, ptoi -- ax and cx are assumed to be free
cr43:
%aw,rw
	mov	ax,A1
	T
	mov	cx,A2
	I	cx

%nw*,rw
	F*
	mov	ax,#1(R*)
	T
	mov	cx,A2
	I	cx

%nw,rw
	F
	mov	ax,R
	T
	mov	cx,A2
	I	cx

%aw,aw
	mov	ax,A1
	T
	I	A2

%nw*,aw
	F*
	mov	ax,#1(R*)
	T
	I	A2

%nw,aw
	F
	mov	ax,R
	T
	I	A2

%nw,ew*
	F
	S1*
	mov	ax,R
	T
	I	#2(R1*)

%nw,nw
	SS
	F
	mov	ax,R
	T
	pop	cx
	I	cx

%nf,af
%nd,ad
	F
S#	lea	ax,A2
S#	call	fdivB2
I#	lea	ax,A2
I#	calli	fdivB2
F#	fdivB2	A2
F#	fwait
X#	fdivB2	A2
X#	fwait

%nf,nf*
%nd,nd*
	F
	S*
S#	lea	ax,#2(R2*)
S#	call	fdivB2
I#	lea	ax,#2(R2*)
I#	calli	fdivB2
F#	fdivB2	#2(R2*)
F#	fwait
X#	fdivB2	#2(R2*)
X#	fwait

%nf,nf
%nd,nd
	F
	S
S#	call	fdivPO
I#	calli	fdivPO
F#	fdivPO
F#	fwait
X#	fdivPO
X#	fwait

/ =+, =|, =&, =^
cr70:
%aw,c
%ab,c
	IB1	A1,A2

%[addq1:]
%aw,rw
%aw,rb
%ab,rb
%ab,rw
	IBE	A1,A2
	movBE	R,A1

%[addq1a:]
%aw,aw
%ab,ab
%aw,ab
%ab,aw
	movB1	R,A1
	IBE	R,A2
	movB1	A1,R

%[addq3:]
%aw,nw
%ab,nb
%aw,nb
%ab,nw
	S
	IBE	A1,R
	movBE	R,A1

%[addq4:]
%nw*,c
%nb*,c
	F*
	IBE	#1(R*),A2
	movBE	R,#1(R*)

%nw*,aw
%nb*,ab
%nw*,ab
%nb*,aw
	F*
	movBE	ax,A2
	IBE	#1(R*),ax
	movBE	R,#1(R*)
C#	old code resulted in memory,memory instruction - july 25
C#	see nw*,c for oldd template

%[addq5:]
%ew*,nw
%eb*,nb
%ew*,nb
%eb*,nw
	S!
	F1*
	IBE	#1(R1*),R
	movBE	R,#1(R1*)

%[addq8:]
%nw*,nw
%nb*,nb
%nw*,nb
%nb*,nw
	SS
	F*
	pop	ax
	IBE	#1(R*),ax
	movBE	R,#1(R*)

%al,c
I#%alp,c
X#%alp,c
	I	A1,A2
	V	A1+,*0.

%nl*,c
I#%nlp*,c
X#%nlp*,c
	F*
	I	#1+2(R*),A2
	V	#1(R*),*0.

%[addq9:]
%nl*,nl
I#%nl*,nlp
I#%nlp*,nl
X#%nl*,nlp
X#%nlp*,nl
	SS
	F1*
	mov	R,#1(R1*)
	mov	R+,#1+2(R1*)
	pop	cx
	pop	ax
	I	R+,ax
	V	R,cx
	mov	#1(R1*),R
	mov	#1+2(R1*),R+

%[addq10:]
%af,nf
%ad,nd
	S
S#	lea	ax,A1
S#	call	fIB1
S#	lea	ax,A1
S#	call	fstB1PP
I#	lea	ax,A1
I#	calli	fIB1
I#	lea	ax,A1
I#	calli	fstB1PP
F#	fIB1	A1
F#	fstB1PP	A1
F#	fwait
X#	fIB1	A1
X#	fstB1PP	A1
X#	fwait

/dont optimize across the comment!
%[addq11:]
%nf*,nf
%nd*,nd
	S
	F*
S#	lea	ax,#1(R*)
I#	lea	ax,#1(R*)
S#|
I#|
S#	push	ax
S#	call	fIB1
S#	pop	ax
S#	call	fstB1PP
I#	push	ax
I#	calli	fIB1
I#	pop	ax
I#	calli	fstB1PP
F#	fIB1	#1(R*)
F#	fstB1PP	#1(R*)
F#	fwait
X#	fIB1	#1(R*)
X#	fstB1PP	#1(R*)
X#	fwait

/ =-
cr71:
%aw,c
%ab,c
	IB1	A1,A2

%aw,rw
%aw,rb
%ab,rb
%ab,rw
%	[addq1]

%aw,aw
%ab,ab
%aw,ab
%ab,aw
%	[addq1a]

%aw,nw
%ab,nb
%aw,nb
%ab,nw
%	[addq3]

%nw*,aw
%nb*,ab
%nw*,ab
%nb*,aw
%	[addq4]

%ew*,nw
%eb*,nb
%ew*,nb
%eb*,nw
%	[addq5]

%nw*,nw
%nb*,nb
%nw*,nb
%nb*,nw
%	[addq8]

%al,c
I#%alp,c
X#%alp,c
	I	A1,A2
	V	A1+,*0.

%nl*,c
I#%nlp*,c
X#%nlp*,c
	F*
	I	#1+2(R*),A2
	V	#1(R*),*0.

%nl*,nl
%	[addq9]

%af,af
%ad,ad
	F
S#	lea	ax,A2
I#	lea	ax,A2
S#	call	fIB2
I#	calli	fIB2
S#	lea	ax,A1
I#	lea	ax,A1
S#	call	fstB1PP
I#	calli	fstB1PP
F#	fIB2	A2
F#	fstB1PP	A1
F#	fwait
X#	fIB2	A2
X#	fstB1PP	A1
X#	fwait

%af,nf*
%ad,nd*
	F
	S*
S#	lea	ax,#2(R2*)
S#	call	fIB2
S#	lea	ax,A1
S#	call	fstB1PP
I#	lea	ax,#2(R2*)
I#	calli	fIB2
I#	lea	ax,A1
I#	calli	fstB1PP
F#	fIB2	#2(R2*)
F#	fstB1PP	A1
F#	fwait
X#	fIB2	#2(R2*)
X#	fstB1PP	A1
X#	fwait

%af,nf
%ad,nd
	F
	S
S#	call	fI
S#	lea	ax,A1
S#	call	fstB1PP
I#	calli	fI
I#	lea	ax,A1
I#	calli	fstB1PP

/ dont optimize across the comment
%nf*,nf
%nd*,nd
	F*
S#	lea	ax,#1(R*)
I#	lea	ax,#1(R*)
S#|
I#|
S#	push	ax
I#	push	ax
S#	call	fldB1PU
I#	calli	fldB1PU
F#	fldB1PU	#1(R*)
F#	fwait
X#	fldB1PU	#1(R*)
X#	fwait
	S
S#	call	fIPO
I#	calli	fIPO
S#	pop	ax
I#	pop	ax
S#	call	fstB1PP
I#	calli	fstB1PP
F#	fIPO
F#	fstB1PP	#1(R*)
F#	fwait
X#	fIPO
X#	fstB1PP	#1(R*)
X#	fwait

/ =*
cr72:
%aw,rw
	mov	ax,A1
	mov	cx,A2
	I	cx
	mov	A1,ax

%nw*,rw
	F*
	mov	ax,#1(R*)
	mov	cx,A2
	I	cx
	mov	#1(R*),ax

%aw,aw
	mov	ax,A1
	I	A2
	mov	A1,ax

%aw,nw
	S
	mov	ax,R
	I	A1
	mov	A1,ax

%nw*,aw
	F*
	mov	ax,#1(R*)
	I	A2
	mov	#1(R*),ax

%nw*,nw
	SS
	F*
	pop	ax
	I	#1(R*)
	mov	#1(R*),ax

%af,nf
%ad,nd
	S
S#	lea	ax,A1
I#	lea	ax,A1
S#	call	fmulB1
I#	calli	fmulB1
S#	lea	ax,A1
I#	lea	ax,A1
S#	call	fstB1PP
I#	calli	fstB1PP
F#	fmulB1	A1
F#	fstB1PP	A1
F#	fwait
X#	fmulB1	A1
X#	fstB1PP	A1
X#	fwait

/ dont optimize across the comment
%nf*,nf
%nd*,nd
	S
	F*
S#	lea	ax,#1(R*)
I#	lea	ax,#1(R*)
S#|
I#|
S#	push	ax
S#	call	fmulB1
S#	pop	ax
S#	call	fstB1PP
I#	push	ax
I#	calli	fmulB1
I#	pop	ax
I#	calli	fstB1PP
F#	fmulB1	#1(R*)
F#	fstB1PP	#1(R*)
F#	fwait
X#	fmulB1	#1(R*)
X#	fstB1PP	#1(R*)
X#	fwait


/ eq slash
cr73:
%aw,rw
	mov	ax,A1
	T
	mov	cx,A2
	I	cx
	mov	A1,ax

%nw*,rw
	F*
	mov	ax,#1(R*)
	T
	mov	cx,A2
	I	cx
	mov	#1(R*),ax

%aw,aw
	mov	ax,A1
	T
	I	A2
	mov	A1,ax

%aw,nw
	S
	mov	cx,R
	mov	ax,A1
	T
	I	cx
	mov	A1,ax

%nw*,aw
	F*
	mov	ax,#1(R*)
	T
	I	A2
	mov	#1(R*),ax

%nw*,nw
	SS
	F*
	mov	ax,#1(R*)
	T
	pop	cx
	I	cx
	mov	#1(R*),ax

%af,af
%ad,ad
	F
S#	lea	ax,A2
S#	call	fdivB2
S#	lea	ax,A1
S#	call	fstB1PP
I#	lea	ax,A2
I#	calli	fdivB2
I#	lea	ax,A1
I#	calli	fstB1PP
F#	fdivB2	A2
F#	fstB1PP	A1
F#	fwait
X#	fdivB2	A2
X#	fstB1PP	A1
X#	fwait

%af,nf*
%ad,nd*
	F
	S*
S#	lea	ax,#2(R2*)
I#	lea	ax,#2(R2*)
S#	call	fdivB2
I#	calli	fdivB2
S#	lea	ax,A1
I#	lea	ax,A1
S#	call	fstB1PP
I#	calli	fstB1PP
F#	fdivB2	#2(R2*)
F#	fstB1PP	A1
F#	fwait
X#	fdivB2	#2(R2*)
X#	fstB1PP	A1
X#	fwait

%af,nf
%ad,nd
	F
	S
S#	call	fdiv
S#	lea	ax,A1
S#	call	fstB1PP
I#	calli	fdiv
I#	lea	ax,A1
I#	calli	fstB1PP
F#	fdiv
F#	fstB1PP	A1
F#	fwait
X#	fdiv
X#	fstB1PP	A1
X#	fwait

/ dont optimize across the comment
%nf*,nf
%nd*,nd
	F*
S#	lea	ax,#1(R*)
I#	lea	ax,#1(R*)
S#|
I#|
S#	push	ax
I#	push	ax
S#	call	fldB1PU
I#	calli	fldB1PU
F#	fldB1PU	#1(R*)
F#	fwait
X#	fldB1PU	#1(R*)
X#	fwait
	S
S#	call	fdivPO
S#	pop	ax
S#	call	fstB1PP
I#	calli	fdivPO
I#	pop	ax
I#	calli	fstB1PP
F#	fdivPO
F#	fstB1PP	#1(R*)
F#	fwait
X#	fdivPO
X#	fstB1PP	#1(R*)
X#	fwait

/ =mod
cr74:
%aw,rw
	mov	ax,A1
	T
	mov	cx,A2
	I	cx
	mov	A1,dx

%nw*,rw
	F*
	mov	ax,#1(R*)
	T
	mov	cx,A2
	I	cx
	mov	#1(R*),dx

%aw,aw
	mov	ax,A1
	T
	I	A2
	mov	A1,dx

%aw,nw
	S
	mov	cx,R
	mov	ax,A1
	T
	I	cx
	mov	A1,dx

%nw*,aw
	F*
	mov	ax,#1(R*)
	T
	I	A2
	mov	#1(R*),dx

%nw*,nw
	SS
	F*
	mov	ax,#1(R*)
	T
	pop	cx
	I	cx
	mov	#1(R*),dx

/ =<<
cr76:
%a,z
	|	shift of 0 missing
	movB1	R,A1

%n*,z
	F*
	|	shift of 0 missing
	movB1	R,#1(R*)


%a,1
	IB1	A1,*1
	movB1	R,A1

%n*,1
	F*
	IB1	#1(R*),*1
	movB1	R,#1(R*)

%a,a
	movB2	cx,A2
	IB1	A1,cl
	movB1	R,A1

%a,n*
	S*
	movB2	cx,#2(R*)
	IB1	A1,cl
	movB1	R,A1

%a,n
	S
	movB2	cx,R
	IB1	A1,cl
	movB1	R,A1

%n*,a
	F*
	movB2	cx,A2
	IB1	#1(R*),cl
	movB1	R,#1(R*)

%n*,e*
	F*
	S1*
	movB2	cx,#2(R1*)
	IB1	#1(R*),cl
	movB1	R,#1(R*)

%n*,e
	F*
	S
	movB2	cx,R1
	IB1	#1(R*),cl
	movB1	R,#1(R*)

%n*,n
	SS
	F*
	pop	cx
	IB1	#1(R*),cl
	movB1	R,#1(R*)

/ my new hacks for <<= of long

%al,z
	| shift 0 of long removed

%nl,z
%nl*,z
	F*
	| shift	0 of long missing

%al,1
	I	A1+,*1
	I'	A1,*1
	mov	R,A1
	mov	R+,A1+

%nl*,1
	F*
	I	#1+2(R*),*1
	I'	#1(R*),*1
	mov	R,#1(R1*)
	mov	R+,#1+2(R1*)

/ the subsequent operations are	chosen for speed
/ for the case of many iterations.  for	the few	iterations
/ case,	it would be better to do the operations	in memory.
/ that would be	smaller, too.

%al,c
	F
	mov	cx,A2
	I	R+,*1
	I'	R,*1
	loop	.-4
	mov	A1,R
	mov	A1+,R+

%al,a
	F
	mov	cx,A2
	or	cx,cx
	jz	.+16
	I	R+,*1
	I'	R,*1
	loop	.-4
	mov	A1,R
	mov	A1+,R+

%al,n
	SS
	F
	pop	cx
	or	cx,cx
	jz	.+16
	I	R+,*1
	I'	R,*1
	loop	.-4
	mov	A1,R
	mov	A1+,R+

%nl*,c
	F1*
	mov	R,#1+2(R1*)
	mov	R+,#1(R1*)
	mov	cx,A2
	I	R+,*1
	I'	R,*1
	loop	.-4
	mov	#1(R1*),R
	mov	#1+2(R1*),R+

%nl*,a
	F1*
	mov	R,#1(R1*)
	mov	R+,#1+2(R1*)
	mov	cx,A2
	or	cx,cx
	jz	.+16.
	I	R+,*1
	I'	R,*1
	loop	.-4
	mov	#1(R1*),R
	mov	#1+2(R1*),R+

%nl*,n
	SS
	F1*
	mov	R,#1(R1*)
	mov	R+,#1+2(R1*)
	pop	cx
	or	cx,cx
	jz	.+16.
	I	R+,*1
	I'	R,*1
	loop	.-4
	mov	#1(R1*),R
	mov	#1+2(R1*),R+

%al,nl
	SS
	mov	R,A1
	mov	R+,A1+
	pop	cx
	or	cx,cx
	jz	.+16.
	I	R+,*1
	I'	R,*1
	loop	.-4
	mov	A1,R
	mov	A1+,R+
	pop	cx

%nl*,nl
	SS
	F1*
	mov	R,#1(R1*)
	mov	R+,#1+2(R1*)
	pop	cx
	or	cx,cx
	jz	.+16.
	I	R+,*1
	I'	R,*1
	loop	.-4
	mov	#1(R1*),R
	mov	#1+2(R1*),R+
	pop	cx

/ =>>, unsigned	=>>
cr75:
%a,z
	|	shift of 0 removed
	movB1	R,A1

%n*,z
	F*
	|	shift of 0 removed
	movB1	R,#1(R*)

%a,1
	IB1	A1,*1
	movB1	R,A1

%n*,1
	F*
	IB1	#1(R*),*1
	movB1	R,#1(R*)

%a,a
	movB2	cx,A2
	IB1	A1,cl
	movB1	R,A1

%a,n*
	S*
	movB2	cx,#2(R*)
	IB1	A1,cl
	movB1	R,A1

%a,n
	S
	movB2	cx,R
	IB1	A1,cl
	movB1	R,A1

%n*,a
	F*
	movB2	cx,A2
	IB1	#1(R*),cl
	movB1	R,#1(R*)

%n*,e*
	F*
	S1*
	movB2	cx,#2(R1*)
	IB1	#1(R*),cl
	movB1	R,#1(R*)

%n*,e
	F*
	S
	movB2	cx,R1
	IB1	#1(R*),cl
	movB1	R,#1(R*)

%n*,n
	SS
	F*
	pop	cx
	IB1	#1(R*),cl
	movB1	R,#1(R*)

/ my new hacks for >>= of long

%al,z
	| shift	0 of long missing

%nl*,z
	F*
	| shift	0 of long missing

%al,1
	I	A1,*1
	I'	A1+,*1
	mov	R,A1
	mov	R+,A1+

%nl*,1
	F*
	I	#1(R*),*1
	I'	#1+2(R*),*1
	mov	R,#1(R1*)
	mov	R+,#1+2(R1*)

/ the subsequent operations are	chosen for speed
/ for the case of many iterations.  for	the few	iterations
/ case,	it would be better to do the operations	in memory.
/ that would be	smaller, too.

%al,c
	F
	mov	cx,A2
	I	R,*1
	I'	R+,*1
	loop	.-4
	mov	A1,R
	mov	A1+,R+

%al,a
	F
	mov	cx,A2
	or	cx,cx
	jz	.+16
	I	R,*1
	I'	R+,*1
	loop	.-4
	mov	A1,R
	mov	A1+,R+

%al,n
	SS
	F
	pop	cx
	or	cx,cx
	jz	.+16
	I	R,*1
	I'	R+,*1
	loop	.-4
	mov	A1,R
	mov	A1+,R+

%nl*,c
	F1*
	mov	R,#1(R1*)
	mov	R+,#1+2(R1*)
	mov	cx,A2
	I	R,*1
	I'	R+,*1
	loop	.-4
	mov	#1(R1*),R
	mov	#1+2(R1*),R+

%nl*,a
	F1*
	mov	R,#1(R1*)
	mov	R+,#1+2(R1*)
	mov	cx,A2
	or	cx,cx
	jz	.+16.
	I	R,*1
	I'	R+,*1
	loop	.-4
	mov	#1(R1*),R
	mov	#1+2(R1*),R+

%nl*,n
	SS
	F1*
	mov	R,#1(R1*)
	mov	R+,#1+2(R1*)
	pop	cx
	or	cx,cx
	jz	.+16.
	I	R,*1
	I'	R+,*1
	loop	.-4
	mov	#1(R1*),R
	mov	#1+2(R1*),R+

%al,nl
	SS
	mov	R,A1
	mov	R+,A1+
	pop	cx
	or	cx,cx
	jz	.+16.
	I	R,*1
	I'	R+,*1
	loop	.-4
	mov	A1,R
	mov	A1+,R+
	pop	cx

%nl*,nl
	SS
	F1*
	mov	R,#1(R1*)
	mov	R+,#1+2(R1*)
	pop	cx
	or	cx,cx
	jz	.+16.
	I	R,*1
	I'	R+,*1
	loop	.-4
	mov	#1(R1*),R
	mov	#1+2(R1*),R+
	pop	cx


/ integer to double
cr51:
FX#%rw,n
FX#	mov	fac,A1
FX#	f16ldPU	fac
FX#	fwait
FX#
FX#%aw,n
FX#	f16ldPU	A1
FX#	fwait
FX#
FX#%nw*,n
FX#	F*
FX#	f16ldPU	#1(R*)
FX#	fwait
FX#
%n,n
	F
IS#	T
S#	call	itofPU
I#	calli	itofPU
FX#	mov	fac,R
FX#	f16ldPU	fac
FX#	fwait

/ double to integer
cr52:
%nf,n
%nd,n
	F
S#	call	ftoiPO
I#	calli	ftoiPO
F#	call	ftoiPO
X#	calli	ftoiPO

/ double to long
cr56:
%nf,n
%nd,n
	F
S#	call	ftolPO
I#	calli	ftolPO
F#	call	ftolPO
X#	calli	ftolPO

/ long to double
cr57:
%nl,n
IS#	FS
S#	call	ltofPU
I#	calli	ltofPU
IS#	add	sp,*4
FX#	F
FX#	mov	fac+2,R
FX#	mov	fac,R+
C#	note concept of long is reveresed
FX#	f32ldPU	fac
FX#	fwait

/ integer to long
cr58:
%nu,n
	F
	mov	ax,R
	sub	dx,dx

%n,n
	F
	mov	ax,R
	cwd

/ long to integer
cr59:
%al,n
	mov	R,A1+

%nl*,n
	F*
	mov	R,#1+2(R*)

/ *, /,	mod for	longs
cr82:
%nl,nl
	SS
	FS
S#	call	Id
I#	calli	Id
F#	call	Id
X#	calli	Id
	add	sp,*8.

/ =*, =/, =mod,	=>> for	longs
/ Operands of the form &x op y,	so stack space is known.
cr86:
%n,nl
	SS
	FS
S#	call	Id
I#	calli	Id
F#	call	Id
X#	calli	Id
	add	sp,*6.

/ convert character to long
cr107:
%a,n
	movb	ax,A1
	cbw
	cwd

%n*,n
	F*
	movb	ax,#1(R*)
	cbw
	cwd

%n,n
	F
	mov	ax,R
	cbw
	cwd

/ convert long to character
cr108:
%al,n
	mov	ax,A1+
	cbw

%nl*,n
	F*
	mov	ax,#1+2(R*)
	cbw

%nl,n
	F
	mov	ax,R+
	cbw

/ convert character to integer or vice versa by	sign extension
cr109:
%r,n
	mov	ax,A1
	T

%a,n
	movb	ax,A1
	cbw

%n*,n
	F*
	movb	ax,#1(R*)
	cbw

%n,n
	F
	mov	ax,R
	cbw

/
/ c code tables	-- compile for side effects.
/ Also set condition codes properly (except for	++, --)
/

.globl	_efftab

.data
_efftab:
	30.;	ci70
	31.;	ci70
	32.;	ci70
	33.;	ci70
	80.;	ci80
	70.;	ci70
	71.;	ci70	/ - like +
	77.;	ci80
	78.;	ci80
	79.;	ci80
	75.;	ci75
	76.;	ci75
	18.;	ci75
	16.;	ci16
	116.;	ci116
	0

/ =, =&, =|, =^
ci80:
%[move1:]
%rw,aw
%aw,rw
%ab,r
	IB1	A1,A2

%[move1a:]
%rw,nw*
%rb,n*
	S*
	IB1	A1,#2(R*)

%[move2:]
%nw*,rw
%nb*,r
	F*
	IB1	#1(R*),A2

%[move5:]
%aw,nw
%ab,n
	S
	IB1	A1,R

%[move10:]
%ew*,nw
%eb*,n
	S!
	F1*
	IB1	#1(R1*),R

%[move12:]
%nw*,nw
%nb*,n
	FS*
	S
	pop	bx
	IB1	#1(bx),R

%al,z
I#%alp,z
	mov	R,A2
	I	A1,R
	I	A1+,R

%[move18:]
%al,c
I#%alp,c
X#%alp,c
	I	A1+,A2
	V	A1,*0

%nl*,c
I#%nlp*,c
X#%nlp*,c
	F*
	I	#1(R*),A2
	I	#1+2(R*),*0

%al,nu*
I#%alp,nu*
X#%alp,nu*
	S*
	I	A1+,#2(R*)
	I	A1,*0

%al,nu
I#%alp,nu
X#%alp,nu
	S
	I	A1+,R
	I	A1,*0

%[move15:]
%al,nl
I#%al,nlp
I#%alp,nl
X#%al,nlp
X#%alp,nl
	S
	I	A1+,R+
	V	A1,R

%[move16:]
%el*,nl
I#%elp*,nl
I#%el*,nlp
X#%elp*,nl
X#%el*,nlp
	S!
	F1*
	I	#1+2(R1*),R+
	V	#1(R1*),R

%[move17:]
%nl*,nl
I#%nlp*,nl
I#%nl*,nlp
X#%nlp*,nl
X#%nl*,nlp
	SS
	F*
	mov	bx,R
	pop	R
	pop	R+
	I	#1+2(bx),R+
	V	#1(bx),R

/ =+, =-, ++, -- (postfix and prefix)
ci70:
%a,z
	| +,- of zero deleted

%a,1
	I'B1	A1

%n*,z
	F*
	| +,- of zero deleted

%n*,1
	F*
	I'B1	#1(R*)

%rw,aw
%rb,a
%aw,rw
%ab,rb
%	[move1]

%rw,nw*
%rb,n*
%	[move1a]

%nw*,rw
%nb*,r
%	[move2]

%aw,nw
%ab,nb
%	[move5]

%ew*,nw
%eb*,n
%	[move10]

%nw*,nw
%nb*,n
%	[move12]

%al,c
I#%alp,c
X#%alp,c
%	[move18]

%al,nl
I#%alp,nl
I#%al,nlp
X#%alp,nl
X#%al,nlp
%	[move15]

%el*,nl
I#%elp*,nl
I#%el*,nlp
X#%elp*,nl
X#%el*,nlp
%	[move16]

%nl*,nl
I#%nl*,nlp
I#%nlp*,nl
X#%nl*,nlp
X#%nlp*,nl
%	[move17]

%af,af
%ad,ad
S#	lea	ax,A1
S#	call	fldB1PU
S#	lea	ax,A2
S#	call	fIB2
S#	lea	ax,A1
S#	call	fstB1pPO
I#	lea	ax,A1
I#	calli	fldB1PU
I#	lea	ax,A2
I#	calli	fIB2
I#	lea	ax,A1
I#	calli	fstB1pPO
F#	fldB1PU	A1
F#	fIB2	A2
F#	fstB1pPO	A1
F#	fwait
X#	fldB1PU	A1
X#	fIB2	A2
X#	fstB1pPO	A1
X#	fwait

/ dont optimize across the comment
%nf*,af
%nd*,ad
	F*
S#	lea	ax,#1(R*)
I#	lea	ax,#1(R*)
S#|
I#|
S#	push	ax
S#	call	fldB1PU
S#	lea	ax,A2
S#	call	fIB2
S#	pop	ax
S#	call	fstB1pPO
I#	push	ax
I#	calli	fldB1PU
I#	lea	ax,A2
I#	calli	fIB2
I#	pop	ax
I#	calli	fstB1pPO
F#	fldB1PU	#1(R*)
F#	fIB2	A2
F#	fstB1pPO	#1(R*)
F#	fwait
X#	fldB1PU	#1(R*)
X#	fIB2	A2
X#	fstB1pPO	#1(R*)
X#	fwait

/ dont optimize across the comment
/ unfortunatly, S has the effect of stomping R*.  so we save
/ it and pop it back again.  the code sucks, but it works.
/ -Hans Dec 15, 82
%nf*,nf
%nd*,nd
	F*
S#	lea	ax,#1(R*)
I#	lea	ax,#1(R*)
S#|
I#|
S#	push	ax
I#	push	ax
S#	call	fldB1PU
I#	calli	fldB1PU
FX#	fldB1PU	#1(R*)
FX#	fwait
FX#	push	R*
	S
S#	call	fIPO
I#	calli	fIPO
S#	pop	ax
I#	pop	ax
S#	call	fstB1pPO
I#	calli	fstB1pPO
FX#	fIPO
FX#	pop	bx
FX#	fstB1pPO	#1(bx)
FX#	fwait

/ =>> ,	=<<, unsigned =>>
ci75:
%a,z
	| shift by 0 removed

%n*,z
	F*
	| shift by 0 removed

%a,1
	IB1	A1,*1

%n*,1
	F*
	IB1	#1(R*),*1

%a,a
	movB2	cx,A2
	IB1	A1,cl

%a,n*
	S*
	movB2	cx,#2(R*)
	IB1	A1,cl

%a,n
	S
	movB2	cx,R
	IB1	A1,cl

%n*,a
	F*
	movB2	cx,A2
	IB1	#1(R*),cl

%n*,e*
	F*
	S1*
	movB2	cx,#2(R1*)
	IB1	#1(R*),cl

%n*,e
	F*
	S
	movB2	cx,R1
	IB1	#1(R*),cl

%n*,n
	SS
	F*
	pop	cx
	IB1	#1(R*),cl

/ field	= ...
ci16:
%a,r
	andB1	A1,Z
	orB1	A1,A2

%a,n
	S
	andB1	A1,Z
	orB1	A1,R

%n*,r
	F*
	andB1	#1(R*),Z
	orB1	#1(R*),A2

%[fas1:]
%e*,n
	S
	F1*
	andB1	#1(R1*),Z
	orB1	#1(R1*),R

%n*,e
	F*
	S1
	andB1	#1(R*),Z
	orB1	#1(R*),R1

%n*,n
	SS
	F*
	andB1	#1(R*),Z
	pop	ax
	orB1	#1(R*),ax

/
/ c code tables-- set condition	codes
/  (uses pieces	of efftab where	appropriate)
/

.globl	_cctab

.data
_cctab:
	106.;	cc106
	30.;	cc70
	31.;	cc70
	34.;	rest
	37.;	rest
	38.;	rest
	40.;	rest
	41.;	rest
	45.;	rest
	46.;	rest
	47.;	cc47
	48.;	rest
	49.;	rest
	60.;	cc60
	61.;	cc60
	62.;	cc60
	63.;	cc60
	64.;	cc60
	65.;	cc60
	66.;	cc60
	67.;	cc60
	68.;	cc60
	69.;	cc60
	70.;	cc70
	71.;	cc70
	75.;	ci75
	76.;	ci75
	18.;	ci75
	77.;	ci80
	78.;	ci80
	79.;	ci80
	0

/ single operand compare
cc106:
%c,n
	movB1	R,A1
	testB1	R,R

%a,n
	cmpB1	A1,*0

%n*,n
	F*
	cmpB1	#1(R*),*0

%n,n
	F
	testB1	R,R

%nl*,n
I#%nlp*,n
X#%nlp*,n
	F*
	cmp	#1(R*),*0
	X0
	cmp	#1+2(R*),*0
	X1

%nl,n
I#%nlp,n
X#%nlp,n
	F
	cmp	R,*0
	X0
	cmp	R+,*0
	X1

%nf,n
%nd,n
	F

/ and
cc47:
%rw,c
%rb,c
%aw,c
%ab,c
	testB1	A1,A2

%n*,c
%nb*,c
	F*
	testB1	#1(R*),A2

%c,n*
%c,nb*
	S*
	testB2	#2(R*),A1

%nw,aw
%nb,ab
%	[add1]

%nw,ew*
%nb,eb*
%	[add2]

%nw,ew
%nb,eb
%	[add3]

%nw,nw*
%nb,nb*
%	[add4]

%nw,n
%nb,n
%	[add5]

/ relationals
cc60:
%rw,aw
%aw,rw
%rb,ab
%ab,rb
%	[move1]

%r,n*
%a,n*
%	[move1a]

%nw*,rw
%nb*,rb
%	[move2]

%aw,nw
%ab,n
%rw,nw
%rb,n
%	[move5]

/ new entry  -hans mar 9 83
%nw*,c
%nb*,c
	F*
	IB1	#1(R*),A2

/ replaced the label with correct code   -hans mar 9 83
%nw,a
%nb,a
%nw,r
%nb,r
	F
	IB1	R,A2

%nw,ew*
%nb,eb*
%	[add2]

%nw,ew
%nb,eb
%	[add3]

%nw*,nw
%nb*,nb
%	[move12]

%nw,nw
%nb,nb
%	[add5]

%al,c
I#%alp,c
X#%alp,c
	I	A1,*0
	X0
	I	A1+,A2
	X1

%[longc1:]
%nl*,z
I#%nlp*,z
X#%nlp*,z
	F*
	I	#1(R*),*0
	X0
	I	#1+2(R*),*0
	X1

%nl*,c
%nl*,au
I#%nlp*,c
I#%nlp*,au
X#%nlp*,c
X#%nlp*,au
	F*
	I	#1(R*),*0
	X0
	I	#1+2(R*),A2
	X1

%[longc2:]
%nl,z
I#%nlp,z
X#%nlp,z
	F
	I	R,*0
	X0
	I	R+,*0
	X1

%nl,c
%nl,au
IX#%nlp,c
IX#%nlp,au
	F
	I	R,*0
	X0
	I	R+,A2
	X1

%nl,al
IX#%nlp,al
IX#%nlp,alp
IX#%nl,alp
	F
	I	R,A2
	X0
	I	R+,A2+
	X1

%nl,el*
IX#%nlp,el*
IX#%nlp,elp*
IX#%nl,elp*
	F
	S1*
	I	R,#2(R1*)
	X0
	I	R+,#2+2(R1*)
	X1

%nl,nl
IX#%nlp,nlp
IX#%nl,nlp
IX#%nlp,nl
	SS
	F
	pop	cx
	pop	bx
	I	R,cx
	X0
	I	R+,bx
	X1

%nf,nf
%nd,nd
	F
	S
SF#	call	fcmpPOPO
IX#	calli	fcmpPOPO
	sahf

/ =+, =-, ++, -- (postfix and prefix)
cc70:
%a,z
	| =,- of zero deleted

%a,1
	I'B1	A1

%n*,z
	F*
	| =,- of zero deleted

%n*,1
	F*
	I'B1	#1(R*)

%rw,aw
%rb,a
%aw,rw
%ab,rb
%	[move1]

%rw,nw*
%rb,n*
%	[move1a]

%nw*,rw
%nb*,r
%	[move2]

%aw,nw
%ab,nb
%	[move5]

%ew*,nw
%eb*,n
%	[move10]

%nw*,nw
%nb*,n
%	[move12]

/ set codes right
rest:
%n,n
	H

/
/ c code tables-- expression pushed onto stack
/

.globl	_sptab

.data
_sptab:
	106.;	cs106
	0

/ name
cs106:
%c,n
	mov	R,A1
	push	R

%al,n
IX#%alp,n
	mov	R,A1+
	push	R
	mov	R,A1
	push	R

%aw,n
	push	A1

%nw*,n
	F*
	push	#1(R*)

%nl*,n
IX#%nlp*,n
	F*
	push	#1+2(R*)
	push	#1(R*)

%nf,n
%nd,n
	F
	sub	sp,*8
IS#	mov	ax,sp
S#	call	fstdpPO
I#	calli	fstdpPO
FX#	xchg	ax,si
FX#	mov	si,sp
FX#	fstdpPO	(si)
FX#	fwait
FX#	xchg	ax,si
C#	this is disgusting!!!!

/ setup	for structure assign
ci116:
%n,n
	FS
	SS

/ end of code tables!
