/********************************************************************
 *
 *	TITLE:	   cio
 *
 *	DATE:	   05-26-82
 *
 *	ABSTRACT:  .
 *
 *	LANGUAGE DEPENDENCIES:
 *
 *		C86     VERSION 1.0
 *
 *********************************************************************/
#include <ctype.h>
#include <curses.h>
#include "common.def"

/********************************************************************
 *
 *	TITLE:	   initcio
 *
 *	CALLING SEQUENCE:
 *
 *		   initcio();
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
initcio()
{

	initscr();
	scrollok( stdscr, FALSE );
	nonl();
	noecho();
	crmode();

	clear();
	refresh();

}

/********************************************************************
 *
 *	TITLE:	   erase_ch
 *
 *	CALLING SEQUENCE:
 *
 *		   erase_ch( c );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
erase_ch( c )
char c;
{
extern *_unctrl[];
int i;

	for (i = strlen(_unctrl[c&0177]); i; i-- )
		addch( '\b' );
	clrtoeol();
	refresh();
}

/********************************************************************
 *
 *	TITLE:	   get_str
 *
 *	CALLING SEQUENCE:
 *
 *		   get_str( sp );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
get_str(sp)
char *sp;
{
char *endsp;

	endsp = sp + STRMAX;
	while( sp < endsp && ((*sp = getch()) != '\n' ) ) {
		if (*sp == _tty.sg_erase) { 
			erase_ch( *sp );
			if (sp > endsp - STRMAX) {
				--sp;
				erase_ch( *sp );
			}
		}
		else 
			++sp;
	}
	*sp = '\0';
}

/********************************************************************
 *
 *	TITLE:	   query
 *
 *	CALLING SEQUENCE:
 *
 *		   query( y, x, prompt, response );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
query( y, x, prompt, response )
int y;
int x;
char *prompt;
char *response;
{

	move( y, x );

	clrtoeol();

	mvaddstr( y, x, prompt );

	refresh();

	move( y, strlen( prompt ) );

	nl();
	echo();
	get_str( response );
	noecho();
	nonl();
}

/********************************************************************
 *
 *	TITLE:	   query_int
 *
 *	CALLING SEQUENCE:
 *
 *		   query_int( y, x, prompt );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
query_int( y, x, prompt )
int y;
int x;
char *prompt;
{
char ascii[16];

	query( y, x, prompt, ascii );
	return( atoi( ascii ) );
}

/********************************************************************
 *
 *	TITLE:	   xrefresh
 *
 *	CALLING SEQUENCE:
 *
 *		   xrefresh( message );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
xrefresh( message )
struct msg_dsc *message;
{

	message->code = REFCODE;
	xwrite( message );
}

/********************************************************************
 *
 *	TITLE:	   refscr
 *
 *	CALLING SEQUENCE:
 *
 *		   refscr( message );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
refscr( message )
struct msg_dsc *message;
{

	message->code = XREFCUR;
	xwrite( message );
}

/********************************************************************
 *
 *	TITLE:	   xadd
 *
 *	CALLING SEQUENCE:
 *
 *		   xadd( message, y, x );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
xadd( message, y, x )
struct msg_dsc *message;
int y;
int x;
{

	message->code = STRCODE;
	message->y = y;
	message->x = x;
	xwrite( message );
}

/********************************************************************
 *
 *	TITLE:	   xaddstr
 *
 *	CALLING SEQUENCE:
 *
 *		   xaddstr( message, y, x, str );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
xaddstr( message, y, x, str )
struct msg_dsc *message;
int y;
int x;
char *str;
{

	strcpy( message->msg, str );
	xadd( message, y, x );
}

/********************************************************************
 *
 *	TITLE:	   xfadd
 *
 *	CALLING SEQUENCE:
 *
 *		   xfadd( message, y, x );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
xfadd( message, y, x )
struct msg_dsc *message;
int y;
int x;
{

	message->code = FCODE;
	message->y = y;
	message->x = x;
	xwrite( message );
}

/********************************************************************
 *
 *	TITLE:	   xfstr
 *
 *	CALLING SEQUENCE:
 *
 *		   xfstr( message, y, x, str );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
xfstr( message, y, x, str )
struct msg_dsc *message;
int y;
int x;
char *str;
{

	strcpy( message->msg, str );
	xfadd( message, y, x );
}

