
/********************************************************************
 *
 *	TITLE:	   pipes
 *
 *	DATE:	   05-26-82
 *
 *	ABSTRACT:  .
 *
 *	LANGUAGE DEPENDENCIES:
 *
 *		C86     VERSION 1.0
 *
 *********************************************************************/
#include <curses.h>
#include <signal.h>
#include "common.def"

	/*
	 *  Static varibles
	 */

static int semafd[2];
static int fd[2];
static char flag[1] = { 's' };

/********************************************************************
 *
 *	TITLE:	   sema
 *
 *	CALLING SEQUENCE:
 *
 *		    sema();
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
sema()
{
int status;

	status = pipe( semafd );
	if ( status == E_IO )
		err_msg( "Bad create of semaphore pipe", "", TRUE );
	unlock();
}

/********************************************************************
 *
 *	TITLE:	   unlock
 *
 *	CALLING SEQUENCE:
 *
 *		   unlock();
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
unlock()
{
int actual;

	actual = write( semafd[1], flag, sizeof(flag) );
	if ( actual == E_IO )
		err_msg( "Bad write of semaphore pipe", "", TRUE );
}

/********************************************************************
 *
 *	TITLE:	   lock
 *
 *	CALLING SEQUENCE:
 *
 *		   lock();
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
lock()
{
int actual;

	actual = read( semafd[0], flag, sizeof(flag) );
	if ( actual == E_IO )
		err_msg( "Bad read of semaphore pipe", "", TRUE );
}

/********************************************************************
 *
 *	TITLE:	   xpipe
 *
 *	CALLING SEQUENCE:
 *
 *		   xpipe();
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
xpipe()
{
int status;

	status = pipe( fd );
	if ( status == E_IO )
		err_msg( "Bad create of screen pipe", "", TRUE );
}

/********************************************************************
 *
 *	TITLE:	   xwrite
 *
 *	CALLING SEQUENCE:
 *
 *		   xwrite( message );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
xwrite( message )
struct msg_dsc *message;
{
int actual;

	lock();
	actual = write( fd[1], message, sizeof( struct msg_dsc ) );
	if ( actual == E_IO )
		err_msg( "Bad write of screen pipe", "", TRUE );
	unlock();
}

/********************************************************************
 *
 *	TITLE:	   xread
 *
 *	CALLING SEQUENCE:
 *
 *		   xread( message );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
xread( message )
struct msg_dsc *message;
{
int actual;

	actual = read( fd[0], message, sizeof( struct msg_dsc ) );
	if ( actual == E_IO )
		err_msg( "Bad read of screen pipe", "", TRUE );
	return( actual );
}

